#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.84.2),
    on November 01, 2018, at 18:18
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import absolute_import, division
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'Go_Nogo_v1'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=u'C:\\Users\\mcg-user\\Desktop\\Correlation study final\\Inhibition\\Go_Nogo_v1.psyexp',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(1920, 1080), fullscr=True, screen=0,
    allowGUI=True, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "instructions"
instructionsClock = core.Clock()
import numpy
# Setup the Window
win = visual.Window(
    size=(1600, 900), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[1,1,1], colorSpace='rgb',
    blendMode='avg', useFBO=True)

import random

#Variables to store error types:
commerror = 0
ommerror = 0

expInfo['expName']='GNG'
pptFilename='data' + os.path.sep + '%s_%s_%s' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
f_ppt=open(pptFilename+'.csv','w')
f_all=open('data' + os.path.sep + 'GNG_allParticipants_JE.csv','a')
f_ppt.write('Participant,Date, Expname, Trial, Letter, Type, Corresp, Response, Correct, Commerror, Ommerror, RT\n')

Instructions = visual.TextStim(win=win, name='Instructions',
    text="You will see a series of letters.\n\nPress the spacebar every time that you see an 'X'. DO NOT press the spacebar if you see any other letter.\n\nThe letters will be presented sequentially, for a very short amount of time. Please press the spacebar as soon as you see an 'X'.\n\nPlease respond with your dominant hand (i.e. the hand that you write with).\n\nPlease respond as quickly and as accurately as possible.\n\nPress the return key to continue",
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=1.5, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "fixation"
fixationClock = core.Clock()


blankspace = visual.TextStim(win=win, name='blankspace',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=-1.0);
fix = visual.TextStim(win=win, name='fix',
    text='*',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-2.0);

# Initialize components for Routine "practice"
practiceClock = core.Clock()
Practstim = visual.TextStim(win=win, name='Practstim',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.3, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "endofprac"
endofpracClock = core.Clock()
endprac = visual.TextStim(win=win, name='endprac',
    text="That is the end of the practice trials.\n\nRemember: press the spacebar when you see an 'X', and do not press the spacebar for any other letter.\n\nPress the return key to continue.",
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "fixation"
fixationClock = core.Clock()


blankspace = visual.TextStim(win=win, name='blankspace',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=-1.0);
fix = visual.TextStim(win=win, name='fix',
    text='*',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-2.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
Stimulus = visual.TextStim(win=win, name='Stimulus',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.3, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);
trial = 0
commerror = 0
ommerror = 0
corrAns = 0


# Initialize components for Routine "breaker"
breakerClock = core.Clock()
takebreak = visual.TextStim(win=win, name='takebreak',
    text='Please take a break.\n\nPress the return key to continue.',
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "fixation"
fixationClock = core.Clock()


blankspace = visual.TextStim(win=win, name='blankspace',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=-1.0);
fix = visual.TextStim(win=win, name='fix',
    text='*',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-2.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
Stimulus = visual.TextStim(win=win, name='Stimulus',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.3, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);
trial = 0
commerror = 0
ommerror = 0
corrAns = 0


# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "instructions"-------
t = 0
instructionsClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat

key_resp_2 = event.BuilderKeyResponse()
# keep track of which components have finished
instructionsComponents = [Instructions, key_resp_2]
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "instructions"-------
while continueRoutine:
    # get current time
    t = instructionsClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    
    # *Instructions* updates
    if t >= 0.0 and Instructions.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instructions.tStart = t
        Instructions.frameNStart = frameN  # exact frame index
        Instructions.setAutoDraw(True)
    
    # *key_resp_2* updates
    if t >= 0.0 and key_resp_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_2.tStart = t
        key_resp_2.frameNStart = frameN  # exact frame index
        key_resp_2.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_2.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_2.status == STARTED:
        theseKeys = event.getKeys(keyList=['return', 'enter'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_2.keys = theseKeys[-1]  # just the last key pressed
            key_resp_2.rt = key_resp_2.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instructions"-------
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# check responses
if key_resp_2.keys in ['', [], None]:  # No response was made
    key_resp_2.keys=None
thisExp.addData('key_resp_2.keys',key_resp_2.keys)
if key_resp_2.keys != None:  # we had a response
    thisExp.addData('key_resp_2.rt', key_resp_2.rt)
thisExp.nextEntry()
# the Routine "instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
prac_trials = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Practice.xlsx'),
    seed=None, name='prac_trials')
thisExp.addLoop(prac_trials)  # add the loop to the experiment
thisPrac_trial = prac_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisPrac_trial.rgb)
if thisPrac_trial != None:
    for paramName in thisPrac_trial.keys():
        exec(paramName + '= thisPrac_trial.' + paramName)

for thisPrac_trial in prac_trials:
    currentLoop = prac_trials
    # abbreviate parameter names if possible (e.g. rgb = thisPrac_trial.rgb)
    if thisPrac_trial != None:
        for paramName in thisPrac_trial.keys():
            exec(paramName + '= thisPrac_trial.' + paramName)
    
    # ------Prepare to start Routine "fixation"-------
    t = 0
    fixationClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    
    # keep track of which components have finished
    fixationComponents = [blankspace, fix]
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "fixation"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = fixationClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        
        # *blankspace* updates
        if t >= 0.0 and blankspace.status == NOT_STARTED:
            # keep track of start time/frame for later
            blankspace.tStart = t
            blankspace.frameNStart = frameN  # exact frame index
            blankspace.setAutoDraw(True)
        frameRemains = 0.0 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if blankspace.status == STARTED and t >= frameRemains:
            blankspace.setAutoDraw(False)
        
        # *fix* updates
        if t >= 0.25 and fix.status == NOT_STARTED:
            # keep track of start time/frame for later
            fix.tStart = t
            fix.frameNStart = frameN  # exact frame index
            fix.setAutoDraw(True)
        frameRemains = 0.25 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if fix.status == STARTED and t >= frameRemains:
            fix.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "fixation"-------
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    
    # ------Prepare to start Routine "practice"-------
    t = 0
    practiceClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(1.000000)
    # update component parameters for each repeat
    Practstim.setText(Letter)
    prac_response = event.BuilderKeyResponse()
    commerror = 0
    ommerror = 0
    # keep track of which components have finished
    practiceComponents = [Practstim, prac_response]
    for thisComponent in practiceComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "practice"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = practiceClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *Practstim* updates
        if t >= 0.0 and Practstim.status == NOT_STARTED:
            # keep track of start time/frame for later
            Practstim.tStart = t
            Practstim.frameNStart = frameN  # exact frame index
            Practstim.setAutoDraw(True)
        frameRemains = 0.0 + 0.3- win.monitorFramePeriod * 0.75  # most of one frame period left
        if Practstim.status == STARTED and t >= frameRemains:
            Practstim.setAutoDraw(False)
        
        # *prac_response* updates
        if t >= 0.0 and prac_response.status == NOT_STARTED:
            # keep track of start time/frame for later
            prac_response.tStart = t
            prac_response.frameNStart = frameN  # exact frame index
            prac_response.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(prac_response.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        frameRemains = 0.0 + 1- win.monitorFramePeriod * 0.75  # most of one frame period left
        if prac_response.status == STARTED and t >= frameRemains:
            prac_response.status = STOPPED
        if prac_response.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                prac_response.keys = theseKeys[-1]  # just the last key pressed
                prac_response.rt = prac_response.clock.getTime()
                # was this 'correct'?
                if (prac_response.keys == str(Corrresp)) or (prac_response.keys == Corrresp):
                    prac_response.corr = 1
                else:
                    prac_response.corr = 0
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in practiceComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "practice"-------
    for thisComponent in practiceComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if prac_response.keys in ['', [], None]:  # No response was made
        prac_response.keys=None
        # was no response the correct answer?!
        if str(Corrresp).lower() == 'none':
           prac_response.corr = 1  # correct non-response
        else:
           prac_response.corr = 0  # failed to respond (incorrectly)
    # store data for prac_trials (TrialHandler)
    prac_trials.addData('prac_response.keys',prac_response.keys)
    prac_trials.addData('prac_response.corr', prac_response.corr)
    if prac_response.keys != None:  # we had a response
        prac_trials.addData('prac_response.rt', prac_response.rt)
    #code to store and save the different types of errors
    
    if (prac_response.keys == 'space') and (Corrresp == 'None'):
        commerror += 1
    if (prac_response.keys != 'space') and (Corrresp == 'space'):
        ommerror += 1
    
    thisExp.addData ('Commission error?', commerror)
    thisExp.addData ('Omission error?', ommerror)
    
    thisExp.nextEntry()
    
# completed 1 repeats of 'prac_trials'


# ------Prepare to start Routine "endofprac"-------
t = 0
endofpracClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_5 = event.BuilderKeyResponse()
# keep track of which components have finished
endofpracComponents = [endprac, key_resp_5]
for thisComponent in endofpracComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "endofprac"-------
while continueRoutine:
    # get current time
    t = endofpracClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *endprac* updates
    if t >= 0.0 and endprac.status == NOT_STARTED:
        # keep track of start time/frame for later
        endprac.tStart = t
        endprac.frameNStart = frameN  # exact frame index
        endprac.setAutoDraw(True)
    
    # *key_resp_5* updates
    if t >= 0.0 and key_resp_5.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_5.tStart = t
        key_resp_5.frameNStart = frameN  # exact frame index
        key_resp_5.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_5.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_5.status == STARTED:
        theseKeys = event.getKeys(keyList=['return', 'enter'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_5.keys = theseKeys[-1]  # just the last key pressed
            key_resp_5.rt = key_resp_5.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in endofpracComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "endofprac"-------
for thisComponent in endofpracComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_5.keys in ['', [], None]:  # No response was made
    key_resp_5.keys=None
thisExp.addData('key_resp_5.keys',key_resp_5.keys)
if key_resp_5.keys != None:  # we had a response
    thisExp.addData('key_resp_5.rt', key_resp_5.rt)
thisExp.nextEntry()
# the Routine "endofprac" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
exp_trials1 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Stimuli1.xlsx'),
    seed=None, name='exp_trials1')
thisExp.addLoop(exp_trials1)  # add the loop to the experiment
thisExp_trials1 = exp_trials1.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisExp_trials1.rgb)
if thisExp_trials1 != None:
    for paramName in thisExp_trials1.keys():
        exec(paramName + '= thisExp_trials1.' + paramName)

for thisExp_trials1 in exp_trials1:
    currentLoop = exp_trials1
    # abbreviate parameter names if possible (e.g. rgb = thisExp_trials1.rgb)
    if thisExp_trials1 != None:
        for paramName in thisExp_trials1.keys():
            exec(paramName + '= thisExp_trials1.' + paramName)
    
    # ------Prepare to start Routine "fixation"-------
    t = 0
    fixationClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    
    # keep track of which components have finished
    fixationComponents = [blankspace, fix]
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "fixation"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = fixationClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        
        # *blankspace* updates
        if t >= 0.0 and blankspace.status == NOT_STARTED:
            # keep track of start time/frame for later
            blankspace.tStart = t
            blankspace.frameNStart = frameN  # exact frame index
            blankspace.setAutoDraw(True)
        frameRemains = 0.0 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if blankspace.status == STARTED and t >= frameRemains:
            blankspace.setAutoDraw(False)
        
        # *fix* updates
        if t >= 0.25 and fix.status == NOT_STARTED:
            # keep track of start time/frame for later
            fix.tStart = t
            fix.frameNStart = frameN  # exact frame index
            fix.setAutoDraw(True)
        frameRemains = 0.25 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if fix.status == STARTED and t >= frameRemains:
            fix.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "fixation"-------
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    
    # ------Prepare to start Routine "trial"-------
    t = 0
    trialClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(1.000000)
    # update component parameters for each repeat
    Stimulus.setText(Letter)
    response = event.BuilderKeyResponse()
    trial +=1
    # keep track of which components have finished
    trialComponents = [Stimulus, response]
    for thisComponent in trialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "trial"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *Stimulus* updates
        if t >= 0.0 and Stimulus.status == NOT_STARTED:
            # keep track of start time/frame for later
            Stimulus.tStart = t
            Stimulus.frameNStart = frameN  # exact frame index
            Stimulus.setAutoDraw(True)
        frameRemains = 0.0 + 0.3- win.monitorFramePeriod * 0.75  # most of one frame period left
        if Stimulus.status == STARTED and t >= frameRemains:
            Stimulus.setAutoDraw(False)
        
        # *response* updates
        if t >= 0.0 and response.status == NOT_STARTED:
            # keep track of start time/frame for later
            response.tStart = t
            response.frameNStart = frameN  # exact frame index
            response.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(response.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        frameRemains = 0.0 + 1- win.monitorFramePeriod * 0.75  # most of one frame period left
        if response.status == STARTED and t >= frameRemains:
            response.status = STOPPED
        if response.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                response.keys = theseKeys[-1]  # just the last key pressed
                response.rt = response.clock.getTime()
                # was this 'correct'?
                if (response.keys == str(Corrresp)) or (response.keys == Corrresp):
                    response.corr = 1
                else:
                    response.corr = 0
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if response.keys in ['', [], None]:  # No response was made
        response.keys=None
        # was no response the correct answer?!
        if str(Corrresp).lower() == 'none':
           response.corr = 1  # correct non-response
        else:
           response.corr = 0  # failed to respond (incorrectly)
    # store data for exp_trials1 (TrialHandler)
    exp_trials1.addData('response.keys',response.keys)
    exp_trials1.addData('response.corr', response.corr)
    if response.keys != None:  # we had a response
        exp_trials1.addData('response.rt', response.rt)
    #code to score and save the different types of errors
    
    if (response.keys == 'space') and (Corrresp == 'None'):
        commerror = 1
        ommerror = 0
        corrAns = 0
    if (response.keys != 'space') and (Corrresp == 'space'):
        ommerror = 1
        commerror = 0
        corrAns = 0
    if (response.keys == 'space') and (Corrresp == 'space'):
        corrAns = 1
        commerror = 0
        ommerror = 0
    if (response.keys != 'space') and (Corrresp == 'None'):
        corrAns = 1
        commerror = 0
        ommerror = 0
    
    thisExp.addData ('Commission error?', commerror)
    thisExp.addData ('Omission error?', ommerror)
    responsestr = str(response.rt)#convert RT to a string so the non-response (which is the type of list) and a response (which is a type of float) can be stored
    
    f_ppt.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],trial, Letter, Type, Corrresp, response.keys, corrAns, commerror, ommerror, responsestr)) #needs adding to so adds all data to each row
    f_all.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],trial, Letter, Type, Corrresp, response.keys, corrAns, commerror, ommerror, responsestr)) #needs adding to so adds all data to each row
    
    thisExp.nextEntry()
    
# completed 1 repeats of 'exp_trials1'


# ------Prepare to start Routine "breaker"-------
t = 0
breakerClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_3 = event.BuilderKeyResponse()
# keep track of which components have finished
breakerComponents = [takebreak, key_resp_3]
for thisComponent in breakerComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "breaker"-------
while continueRoutine:
    # get current time
    t = breakerClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *takebreak* updates
    if t >= 0.0 and takebreak.status == NOT_STARTED:
        # keep track of start time/frame for later
        takebreak.tStart = t
        takebreak.frameNStart = frameN  # exact frame index
        takebreak.setAutoDraw(True)
    
    # *key_resp_3* updates
    if t >= 0.0 and key_resp_3.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_3.tStart = t
        key_resp_3.frameNStart = frameN  # exact frame index
        key_resp_3.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_3.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_3.status == STARTED:
        theseKeys = event.getKeys(keyList=['return', 'enter'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_3.keys = theseKeys[-1]  # just the last key pressed
            key_resp_3.rt = key_resp_3.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in breakerComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "breaker"-------
for thisComponent in breakerComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_3.keys in ['', [], None]:  # No response was made
    key_resp_3.keys=None
thisExp.addData('key_resp_3.keys',key_resp_3.keys)
if key_resp_3.keys != None:  # we had a response
    thisExp.addData('key_resp_3.rt', key_resp_3.rt)
thisExp.nextEntry()
# the Routine "breaker" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
exp_trials2 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Stimuli2.xlsx'),
    seed=None, name='exp_trials2')
thisExp.addLoop(exp_trials2)  # add the loop to the experiment
thisExp_trials2 = exp_trials2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisExp_trials2.rgb)
if thisExp_trials2 != None:
    for paramName in thisExp_trials2.keys():
        exec(paramName + '= thisExp_trials2.' + paramName)

for thisExp_trials2 in exp_trials2:
    currentLoop = exp_trials2
    # abbreviate parameter names if possible (e.g. rgb = thisExp_trials2.rgb)
    if thisExp_trials2 != None:
        for paramName in thisExp_trials2.keys():
            exec(paramName + '= thisExp_trials2.' + paramName)
    
    # ------Prepare to start Routine "fixation"-------
    t = 0
    fixationClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    
    # keep track of which components have finished
    fixationComponents = [blankspace, fix]
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "fixation"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = fixationClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        
        # *blankspace* updates
        if t >= 0.0 and blankspace.status == NOT_STARTED:
            # keep track of start time/frame for later
            blankspace.tStart = t
            blankspace.frameNStart = frameN  # exact frame index
            blankspace.setAutoDraw(True)
        frameRemains = 0.0 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if blankspace.status == STARTED and t >= frameRemains:
            blankspace.setAutoDraw(False)
        
        # *fix* updates
        if t >= 0.25 and fix.status == NOT_STARTED:
            # keep track of start time/frame for later
            fix.tStart = t
            fix.frameNStart = frameN  # exact frame index
            fix.setAutoDraw(True)
        frameRemains = 0.25 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if fix.status == STARTED and t >= frameRemains:
            fix.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "fixation"-------
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    
    # ------Prepare to start Routine "trial"-------
    t = 0
    trialClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(1.000000)
    # update component parameters for each repeat
    Stimulus.setText(Letter)
    response = event.BuilderKeyResponse()
    trial +=1
    # keep track of which components have finished
    trialComponents = [Stimulus, response]
    for thisComponent in trialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "trial"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *Stimulus* updates
        if t >= 0.0 and Stimulus.status == NOT_STARTED:
            # keep track of start time/frame for later
            Stimulus.tStart = t
            Stimulus.frameNStart = frameN  # exact frame index
            Stimulus.setAutoDraw(True)
        frameRemains = 0.0 + 0.3- win.monitorFramePeriod * 0.75  # most of one frame period left
        if Stimulus.status == STARTED and t >= frameRemains:
            Stimulus.setAutoDraw(False)
        
        # *response* updates
        if t >= 0.0 and response.status == NOT_STARTED:
            # keep track of start time/frame for later
            response.tStart = t
            response.frameNStart = frameN  # exact frame index
            response.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(response.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        frameRemains = 0.0 + 1- win.monitorFramePeriod * 0.75  # most of one frame period left
        if response.status == STARTED and t >= frameRemains:
            response.status = STOPPED
        if response.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                response.keys = theseKeys[-1]  # just the last key pressed
                response.rt = response.clock.getTime()
                # was this 'correct'?
                if (response.keys == str(Corrresp)) or (response.keys == Corrresp):
                    response.corr = 1
                else:
                    response.corr = 0
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if response.keys in ['', [], None]:  # No response was made
        response.keys=None
        # was no response the correct answer?!
        if str(Corrresp).lower() == 'none':
           response.corr = 1  # correct non-response
        else:
           response.corr = 0  # failed to respond (incorrectly)
    # store data for exp_trials2 (TrialHandler)
    exp_trials2.addData('response.keys',response.keys)
    exp_trials2.addData('response.corr', response.corr)
    if response.keys != None:  # we had a response
        exp_trials2.addData('response.rt', response.rt)
    #code to score and save the different types of errors
    
    if (response.keys == 'space') and (Corrresp == 'None'):
        commerror = 1
        ommerror = 0
        corrAns = 0
    if (response.keys != 'space') and (Corrresp == 'space'):
        ommerror = 1
        commerror = 0
        corrAns = 0
    if (response.keys == 'space') and (Corrresp == 'space'):
        corrAns = 1
        commerror = 0
        ommerror = 0
    if (response.keys != 'space') and (Corrresp == 'None'):
        corrAns = 1
        commerror = 0
        ommerror = 0
    
    thisExp.addData ('Commission error?', commerror)
    thisExp.addData ('Omission error?', ommerror)
    responsestr = str(response.rt)#convert RT to a string so the non-response (which is the type of list) and a response (which is a type of float) can be stored
    
    f_ppt.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],trial, Letter, Type, Corrresp, response.keys, corrAns, commerror, ommerror, responsestr)) #needs adding to so adds all data to each row
    f_all.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],trial, Letter, Type, Corrresp, response.keys, corrAns, commerror, ommerror, responsestr)) #needs adding to so adds all data to each row
    
    thisExp.nextEntry()
    
# completed 1 repeats of 'exp_trials2'


f_ppt.close()
 

f_ppt.close()
 

f_ppt.close()
 

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
