#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.84.2),
    on September 19, 2018, at 10:16
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import absolute_import, division
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'Letter-number_FINAL'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=u'C:\\Users\\mcg-user\\Desktop\\Correlation study final\\Switching_fixed_order\\Letter-number_FINAL.psyexp',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(1920, 1080), fullscr=True, screen=0,
    allowGUI=True, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "instructions"
instructionsClock = core.Clock()
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np
from numpy import (sin, cos, tan, log, log10, pi, average, median, mean,#some of these help in CI calculations
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding
import random
import time


import numpy
# Setup the Window
win = visual.Window(
    size=(1600, 900), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[1,1,1], colorSpace='rgb',
    blendMode='avg', useFBO=True)

expInfo['expName']='SWITCHING'
pptFilename='data' + os.path.sep + '%s_%s_%s' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
f_ppt=open(pptFilename+'.csv','w')
f_all=open('data' + os.path.sep + 'Switching_allParticipants_JE.csv','a')
f_ppt.write('Participant,Date, Expname, Trial, Stimulus, Location, Type, Corresp, Response, Correct, RT\n')

text = visual.TextStim(win=win, name='text',
    text="You will see a number-letter pair either at the top or at the bottom of the screen.\n\nIf the number is odd, press 'x'. If the number is even, press 'm'.\n\nIf the letter is a consonant, press 'x'. If the letter is a vowel, press 'm'.\n\nOn each trial, you only need to make one response, to the number OR the letter.\n\nIf the number-letter pair is at the top of the screen, respond according to the number (odd/even)\n\nIf the number-letter pair is at the bottom of the screen, respond according to the letter (consonant, vowel)\n\nPress the spacebar to continue",
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=1.5, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "br1"
br1Clock = core.Clock()
text_4 = visual.TextStim(win=win, name='text_4',
    text="We will begin with some practice trials.\n\nThe stimuli will be presented in one of the four locations.\n\nIf the stimulus is in the upper location, categorise it based on the number. If the stimulus is in the lower location, categorise it based on the letter.\n\nPress 'x' if the number is odd, and 'm' if the number is even.\n\nPress 'x' if the letter is a consonant, and 'm' if the letter is a vowel.\n\nPress the spacebar to continue.",
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=1.5, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "prac_switch"
prac_switchClock = core.Clock()
text_8 = visual.TextStim(win=win, name='text_8',
    text='default text',
    font='Times',
    pos=[0,0], height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);
polygon_9 = visual.Line(
    win=win, name='polygon_9',
    start=(-(1, 0.5)[0]/2.0, 0), end=(+(1, 0.5)[0]/2.0, 0),
    ori=0, pos=(0, 0),
    lineWidth=1, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=-2.0, interpolate=True)
polygon_10 = visual.Line(
    win=win, name='polygon_10',
    start=(-(1, 0.5)[0]/2.0, 0), end=(+(1, 0.5)[0]/2.0, 0),
    ori=90, pos=(0, 0),
    lineWidth=1, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=-3.0, interpolate=True)

# Initialize components for Routine "repeatprac"
repeatpracClock = core.Clock()
text_11 = visual.TextStim(win=win, name='text_11',
    text='Press 1 to repeat the practice trials\n\nPress 2 to continue to the main trials',
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "br6"
br6Clock = core.Clock()
text_9 = visual.TextStim(win=win, name='text_9',
    text="That is the end of the practice trials.\n\nPress the spacebar to continue.\n\nRemember: \nIf the number is odd, press 'x'. If the number is even, press 'm'.\nIf the letter is a consonant, press 'x'. If the letter is a vowel, press 'm'.\nIf the number-letter pair is at the top of the screen, respond according to the number (odd/even)\nIf the number-letter pair is at the bottom of the screen, respond according to the letter (consonant, vowel)",
    font='Arial',
    pos=(0, 0), height=0.07, wrapWidth=1.5, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "switchingtrials"
switchingtrialsClock = core.Clock()
switcher = visual.TextStim(win=win, name='switcher',
    text='default text',
    font='Times',
    pos=[0,0], height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);
polygon_3 = visual.Line(
    win=win, name='polygon_3',
    start=(-(1, 0.5)[0]/2.0, 0), end=(+(1, 0.5)[0]/2.0, 0),
    ori=0, pos=(0, 0),
    lineWidth=1, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=-2.0, interpolate=True)
polygon_4 = visual.Line(
    win=win, name='polygon_4',
    start=(-(1, 0.5)[0]/2.0, 0), end=(+(1, 0.5)[0]/2.0, 0),
    ori=90, pos=(0, 0),
    lineWidth=1, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=-3.0, interpolate=True)


# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "instructions"-------
t = 0
instructionsClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat

key_resp_3 = event.BuilderKeyResponse()
# keep track of which components have finished
instructionsComponents = [text, key_resp_3]
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "instructions"-------
while continueRoutine:
    # get current time
    t = instructionsClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    
    # *text* updates
    if t >= 0.0 and text.status == NOT_STARTED:
        # keep track of start time/frame for later
        text.tStart = t
        text.frameNStart = frameN  # exact frame index
        text.setAutoDraw(True)
    
    # *key_resp_3* updates
    if t >= 0.0 and key_resp_3.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_3.tStart = t
        key_resp_3.frameNStart = frameN  # exact frame index
        key_resp_3.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_3.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_3.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_3.keys = theseKeys[-1]  # just the last key pressed
            key_resp_3.rt = key_resp_3.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instructions"-------
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# check responses
if key_resp_3.keys in ['', [], None]:  # No response was made
    key_resp_3.keys=None
thisExp.addData('key_resp_3.keys',key_resp_3.keys)
if key_resp_3.keys != None:  # we had a response
    thisExp.addData('key_resp_3.rt', key_resp_3.rt)
thisExp.nextEntry()
# the Routine "instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "br1"-------
t = 0
br1Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_6 = event.BuilderKeyResponse()
# keep track of which components have finished
br1Components = [text_4, key_resp_6]
for thisComponent in br1Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "br1"-------
while continueRoutine:
    # get current time
    t = br1Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_4* updates
    if t >= 0.0 and text_4.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_4.tStart = t
        text_4.frameNStart = frameN  # exact frame index
        text_4.setAutoDraw(True)
    
    # *key_resp_6* updates
    if t >= 0.0 and key_resp_6.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_6.tStart = t
        key_resp_6.frameNStart = frameN  # exact frame index
        key_resp_6.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_6.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_6.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_6.keys = theseKeys[-1]  # just the last key pressed
            key_resp_6.rt = key_resp_6.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in br1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "br1"-------
for thisComponent in br1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_6.keys in ['', [], None]:  # No response was made
    key_resp_6.keys=None
thisExp.addData('key_resp_6.keys',key_resp_6.keys)
if key_resp_6.keys != None:  # we had a response
    thisExp.addData('key_resp_6.rt', key_resp_6.rt)
thisExp.nextEntry()
# the Routine "br1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
practice = data.TrialHandler(nReps=3, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='practice')
thisExp.addLoop(practice)  # add the loop to the experiment
thisPractice = practice.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisPractice.rgb)
if thisPractice != None:
    for paramName in thisPractice.keys():
        exec(paramName + '= thisPractice.' + paramName)

for thisPractice in practice:
    currentLoop = practice
    # abbreviate parameter names if possible (e.g. rgb = thisPractice.rgb)
    if thisPractice != None:
        for paramName in thisPractice.keys():
            exec(paramName + '= thisPractice.' + paramName)
    
    # set up handler to look after randomisation of conditions etc
    practrials = data.TrialHandler(nReps=1, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('Pseudoprac.xlsx'),
        seed=None, name='practrials')
    thisExp.addLoop(practrials)  # add the loop to the experiment
    thisPractrial = practrials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisPractrial.rgb)
    if thisPractrial != None:
        for paramName in thisPractrial.keys():
            exec(paramName + '= thisPractrial.' + paramName)
    
    for thisPractrial in practrials:
        currentLoop = practrials
        # abbreviate parameter names if possible (e.g. rgb = thisPractrial.rgb)
        if thisPractrial != None:
            for paramName in thisPractrial.keys():
                exec(paramName + '= thisPractrial.' + paramName)
        
        # ------Prepare to start Routine "prac_switch"-------
        t = 0
        prac_switchClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.250000)
        # update component parameters for each repeat
        text_8.setText(Concatenated)
        text_8.setPos(Coords)
        key_resp_11 = event.BuilderKeyResponse()
        # keep track of which components have finished
        prac_switchComponents = [text_8, key_resp_11, polygon_9, polygon_10]
        for thisComponent in prac_switchComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "prac_switch"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = prac_switchClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_8* updates
            if t >= 0.25 and text_8.status == NOT_STARTED:
                # keep track of start time/frame for later
                text_8.tStart = t
                text_8.frameNStart = frameN  # exact frame index
                text_8.setAutoDraw(True)
            frameRemains = 0.25 + 5- win.monitorFramePeriod * 0.75  # most of one frame period left
            if text_8.status == STARTED and t >= frameRemains:
                text_8.setAutoDraw(False)
            
            # *key_resp_11* updates
            if t >= 0.0 and key_resp_11.status == NOT_STARTED:
                # keep track of start time/frame for later
                key_resp_11.tStart = t
                key_resp_11.frameNStart = frameN  # exact frame index
                key_resp_11.status = STARTED
                # keyboard checking is just starting
                win.callOnFlip(key_resp_11.clock.reset)  # t=0 on next screen flip
                event.clearEvents(eventType='keyboard')
            frameRemains = 0.0 + 5.25- win.monitorFramePeriod * 0.75  # most of one frame period left
            if key_resp_11.status == STARTED and t >= frameRemains:
                key_resp_11.status = STOPPED
            if key_resp_11.status == STARTED:
                theseKeys = event.getKeys(keyList=['x', 'm'])
                
                # check for quit:
                if "escape" in theseKeys:
                    endExpNow = True
                if len(theseKeys) > 0:  # at least one key was pressed
                    key_resp_11.keys = theseKeys[-1]  # just the last key pressed
                    key_resp_11.rt = key_resp_11.clock.getTime()
                    # was this 'correct'?
                    if (key_resp_11.keys == str(Corresp)) or (key_resp_11.keys == Corresp):
                        key_resp_11.corr = 1
                    else:
                        key_resp_11.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *polygon_9* updates
            if t >= 0.0 and polygon_9.status == NOT_STARTED:
                # keep track of start time/frame for later
                polygon_9.tStart = t
                polygon_9.frameNStart = frameN  # exact frame index
                polygon_9.setAutoDraw(True)
            frameRemains = 0.0 + 5.25- win.monitorFramePeriod * 0.75  # most of one frame period left
            if polygon_9.status == STARTED and t >= frameRemains:
                polygon_9.setAutoDraw(False)
            
            # *polygon_10* updates
            if t >= 0.0 and polygon_10.status == NOT_STARTED:
                # keep track of start time/frame for later
                polygon_10.tStart = t
                polygon_10.frameNStart = frameN  # exact frame index
                polygon_10.setAutoDraw(True)
            frameRemains = 0.0 + 5.25- win.monitorFramePeriod * 0.75  # most of one frame period left
            if polygon_10.status == STARTED and t >= frameRemains:
                polygon_10.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in prac_switchComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "prac_switch"-------
        for thisComponent in prac_switchComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if key_resp_11.keys in ['', [], None]:  # No response was made
            key_resp_11.keys=None
            # was no response the correct answer?!
            if str(Corresp).lower() == 'none':
               key_resp_11.corr = 1  # correct non-response
            else:
               key_resp_11.corr = 0  # failed to respond (incorrectly)
        # store data for practrials (TrialHandler)
        practrials.addData('key_resp_11.keys',key_resp_11.keys)
        practrials.addData('key_resp_11.corr', key_resp_11.corr)
        if key_resp_11.keys != None:  # we had a response
            practrials.addData('key_resp_11.rt', key_resp_11.rt)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'practrials'
    
    
    # ------Prepare to start Routine "repeatprac"-------
    t = 0
    repeatpracClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_7 = event.BuilderKeyResponse()
    
    # keep track of which components have finished
    repeatpracComponents = [text_11, key_resp_7]
    for thisComponent in repeatpracComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "repeatprac"-------
    while continueRoutine:
        # get current time
        t = repeatpracClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_11* updates
        if t >= 0.0 and text_11.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_11.tStart = t
            text_11.frameNStart = frameN  # exact frame index
            text_11.setAutoDraw(True)
        
        # *key_resp_7* updates
        if t >= 0.0 and key_resp_7.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_7.tStart = t
            key_resp_7.frameNStart = frameN  # exact frame index
            key_resp_7.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(key_resp_7.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if key_resp_7.status == STARTED:
            theseKeys = event.getKeys(keyList=['num_1', 'num_2'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                key_resp_7.keys = theseKeys[-1]  # just the last key pressed
                key_resp_7.rt = key_resp_7.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in repeatpracComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "repeatprac"-------
    for thisComponent in repeatpracComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_resp_7.keys in ['', [], None]:  # No response was made
        key_resp_7.keys=None
    practice.addData('key_resp_7.keys',key_resp_7.keys)
    if key_resp_7.keys != None:  # we had a response
        practice.addData('key_resp_7.rt', key_resp_7.rt)
    if key_resp_7.keys =='num_2':
        print 'check1'
        practice.finished=True
    # the Routine "repeatprac" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 3 repeats of 'practice'


# ------Prepare to start Routine "br6"-------
t = 0
br6Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_12 = event.BuilderKeyResponse()
# keep track of which components have finished
br6Components = [text_9, key_resp_12]
for thisComponent in br6Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "br6"-------
while continueRoutine:
    # get current time
    t = br6Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_9* updates
    if t >= 0.0 and text_9.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_9.tStart = t
        text_9.frameNStart = frameN  # exact frame index
        text_9.setAutoDraw(True)
    
    # *key_resp_12* updates
    if t >= 0.0 and key_resp_12.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_12.tStart = t
        key_resp_12.frameNStart = frameN  # exact frame index
        key_resp_12.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_12.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_12.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_12.keys = theseKeys[-1]  # just the last key pressed
            key_resp_12.rt = key_resp_12.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in br6Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "br6"-------
for thisComponent in br6Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_12.keys in ['', [], None]:  # No response was made
    key_resp_12.keys=None
thisExp.addData('key_resp_12.keys',key_resp_12.keys)
if key_resp_12.keys != None:  # we had a response
    thisExp.addData('key_resp_12.rt', key_resp_12.rt)
thisExp.nextEntry()
# the Routine "br6" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
Exptl_trials = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Pseudostim.xlsx'),
    seed=None, name='Exptl_trials')
thisExp.addLoop(Exptl_trials)  # add the loop to the experiment
thisExptl_trial = Exptl_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisExptl_trial.rgb)
if thisExptl_trial != None:
    for paramName in thisExptl_trial.keys():
        exec(paramName + '= thisExptl_trial.' + paramName)

for thisExptl_trial in Exptl_trials:
    currentLoop = Exptl_trials
    # abbreviate parameter names if possible (e.g. rgb = thisExptl_trial.rgb)
    if thisExptl_trial != None:
        for paramName in thisExptl_trial.keys():
            exec(paramName + '= thisExptl_trial.' + paramName)
    
    # ------Prepare to start Routine "switchingtrials"-------
    t = 0
    switchingtrialsClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(5.250000)
    # update component parameters for each repeat
    switcher.setText(Concatenated)
    switcher.setPos(Coords)
    response = event.BuilderKeyResponse()
    
    # keep track of which components have finished
    switchingtrialsComponents = [switcher, response, polygon_3, polygon_4]
    for thisComponent in switchingtrialsComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "switchingtrials"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = switchingtrialsClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *switcher* updates
        if t >= 0.25 and switcher.status == NOT_STARTED:
            # keep track of start time/frame for later
            switcher.tStart = t
            switcher.frameNStart = frameN  # exact frame index
            switcher.setAutoDraw(True)
        frameRemains = 0.25 + 5- win.monitorFramePeriod * 0.75  # most of one frame period left
        if switcher.status == STARTED and t >= frameRemains:
            switcher.setAutoDraw(False)
        
        # *response* updates
        if t >= 0.25 and response.status == NOT_STARTED:
            # keep track of start time/frame for later
            response.tStart = t
            response.frameNStart = frameN  # exact frame index
            response.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(response.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        frameRemains = 0.25 + 5- win.monitorFramePeriod * 0.75  # most of one frame period left
        if response.status == STARTED and t >= frameRemains:
            response.status = STOPPED
        if response.status == STARTED:
            theseKeys = event.getKeys(keyList=['x', 'm'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                response.keys = theseKeys[-1]  # just the last key pressed
                response.rt = response.clock.getTime()
                # was this 'correct'?
                if (response.keys == str(Corresp)) or (response.keys == Corresp):
                    response.corr = 1
                else:
                    response.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # *polygon_3* updates
        if t >= 0.0 and polygon_3.status == NOT_STARTED:
            # keep track of start time/frame for later
            polygon_3.tStart = t
            polygon_3.frameNStart = frameN  # exact frame index
            polygon_3.setAutoDraw(True)
        frameRemains = 0.0 + 5.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if polygon_3.status == STARTED and t >= frameRemains:
            polygon_3.setAutoDraw(False)
        
        # *polygon_4* updates
        if t >= 0.0 and polygon_4.status == NOT_STARTED:
            # keep track of start time/frame for later
            polygon_4.tStart = t
            polygon_4.frameNStart = frameN  # exact frame index
            polygon_4.setAutoDraw(True)
        frameRemains = 0.0 + 5.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if polygon_4.status == STARTED and t >= frameRemains:
            polygon_4.setAutoDraw(False)
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in switchingtrialsComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "switchingtrials"-------
    for thisComponent in switchingtrialsComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if response.keys in ['', [], None]:  # No response was made
        response.keys=None
        # was no response the correct answer?!
        if str(Corresp).lower() == 'none':
           response.corr = 1  # correct non-response
        else:
           response.corr = 0  # failed to respond (incorrectly)
    # store data for Exptl_trials (TrialHandler)
    Exptl_trials.addData('response.keys',response.keys)
    Exptl_trials.addData('response.corr', response.corr)
    if response.keys != None:  # we had a response
        Exptl_trials.addData('response.rt', response.rt)
    responsestr = str(response.rt)#convert RT to a string so the non-response (which is the type of list) and a response (which is a type of float) can be stored
    
    f_ppt.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'], Trial, Concatenated, Location, Type, Corresp, response.keys, response.corr, responsestr)) #needs adding to so adds all data to each row
    f_all.write('%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'], Trial, Concatenated, Location, Type, Corresp, response.keys, response.corr, responsestr)) #needs adding to so adds all data to each row
    
    
    thisExp.nextEntry()
    
# completed 1 repeats of 'Exptl_trials'




# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
