#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.84.2),
    on November 01, 2018, at 18:11
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import absolute_import, division
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'VS_OddOneOut_Mixed_Blocked'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u'', u'task': u'visuoOOO'}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data' + os.sep + '%s_%s' % (expInfo['participant'], expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=u'C:\\Users\\mcg-user\\Desktop\\Correlation study final\\D3 visuospatial WM\\Visuospatial_OddOneOut_FINAL_adult_Jo.psyexp',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(1920, 1080), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color='white', colorSpace='rgb',
    blendMode='avg', useFBO=True,
    units='cm')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "presentDot"
presentDotClock = core.Clock()
from psychopy import misc
myMouse=event.Mouse(win=win)#defining the mouse, I'm unsure why as it exists as a component itself. The component wasn't in the original code and it therefore didn't work.
#define variables to store datafiles - for ppt and expt separately.
expInfo['expName']='OOO_visuospatialWM'
processingFilename='data' + os.path.sep + '%s_%s_%s_processing' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
storageFilename='data' + os.path.sep + '%s_%s_%s_storage' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
fp=open(processingFilename+'.csv','w')
fs=open(storageFilename+'.csv','w')
fp_all=open('data' + os.path.sep + 'OOO_visuospatialWM_processing_allParticipants_JE.csv','a')
fs_all=open('data' + os.path.sep + 'OOO_visuospatialWM_storage_allParticipants_JE.csv','a')
fp.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,Response,RT,corrSquare\n')
fs.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,responseSequence,clickSequence,spanCorr,proportionScore,itemsCorr,proportionItemScore\n')
#fp_all.write('\n')
#fs_all.write('\n')
response=0
respSequence=[]
Mouse = event.Mouse(win=win)
x, y = [None, None]
square7 = visual.ImageStim(
    win=win, name='square7',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square8 = visual.ImageStim(
    win=win, name='square8',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square3 = visual.ImageStim(
    win=win, name='square3',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square4 = visual.ImageStim(
    win=win, name='square4',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square5 = visual.ImageStim(
    win=win, name='square5',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square9 = visual.ImageStim(
    win=win, name='square9',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square6 = visual.ImageStim(
    win=win, name='square6',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square1 = visual.ImageStim(
    win=win, name='square1',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
square2 = visual.ImageStim(
    win=win, name='square2',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-10.0)
image1_ = visual.ImageStim(
    win=win, name='image1_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-11.0)
image4_ = visual.ImageStim(
    win=win, name='image4_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-12.0)
image3_ = visual.ImageStim(
    win=win, name='image3_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-13.0)
image2_ = visual.ImageStim(
    win=win, name='image2_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-14.0)

# Initialize components for Routine "RepeatPrac"
RepeatPracClock = core.Clock()

text_5 = visual.TextStim(win=win, name='text_5',
    text='Would you like to repeat the practice trials?\n\nPress 1 for Yes \n\nOr press 2 if you would like to start the first game.',
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=None, ori=0, 
    color='blue', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "presentDot"
presentDotClock = core.Clock()
from psychopy import misc
myMouse=event.Mouse(win=win)#defining the mouse, I'm unsure why as it exists as a component itself. The component wasn't in the original code and it therefore didn't work.
#define variables to store datafiles - for ppt and expt separately.
expInfo['expName']='OOO_visuospatialWM'
processingFilename='data' + os.path.sep + '%s_%s_%s_processing' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
storageFilename='data' + os.path.sep + '%s_%s_%s_storage' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
fp=open(processingFilename+'.csv','w')
fs=open(storageFilename+'.csv','w')
fp_all=open('data' + os.path.sep + 'OOO_visuospatialWM_processing_allParticipants_JE.csv','a')
fs_all=open('data' + os.path.sep + 'OOO_visuospatialWM_storage_allParticipants_JE.csv','a')
fp.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,Response,RT,corrSquare\n')
fs.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,responseSequence,clickSequence,spanCorr,proportionScore,itemsCorr,proportionItemScore\n')
#fp_all.write('\n')
#fs_all.write('\n')
response=0
respSequence=[]
Mouse = event.Mouse(win=win)
x, y = [None, None]
square7 = visual.ImageStim(
    win=win, name='square7',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square8 = visual.ImageStim(
    win=win, name='square8',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square3 = visual.ImageStim(
    win=win, name='square3',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square4 = visual.ImageStim(
    win=win, name='square4',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square5 = visual.ImageStim(
    win=win, name='square5',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square9 = visual.ImageStim(
    win=win, name='square9',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square6 = visual.ImageStim(
    win=win, name='square6',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square1 = visual.ImageStim(
    win=win, name='square1',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
square2 = visual.ImageStim(
    win=win, name='square2',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-10.0)
image1_ = visual.ImageStim(
    win=win, name='image1_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-11.0)
image4_ = visual.ImageStim(
    win=win, name='image4_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-12.0)
image3_ = visual.ImageStim(
    win=win, name='image3_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-13.0)
image2_ = visual.ImageStim(
    win=win, name='image2_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-14.0)

# Initialize components for Routine "Instruc_"
Instruc_Clock = core.Clock()
text_20 = visual.TextStim(win=win, name='text_20',
    text="In this task you will be presented with a 3 x 3 grid of black squares.\n\nSome of the squares will contain images. Your task is to pick the image which is the odd-one out, and remember its location.\n\nPlease click on the square that is the odd one out, and remember where it is located.\n\nYou will then be asked to recall the locations of the odd objects, in the order in which they were presented.\n\nWhen you see a      ?     , a black grid will appear and you need to click on the squares that the odd one out was on, in the order that you saw them.\n\nPlease click on the squares only once - do not double click on the same square.\n\nLet's practise...",
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=33, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "presentDot"
presentDotClock = core.Clock()
from psychopy import misc
myMouse=event.Mouse(win=win)#defining the mouse, I'm unsure why as it exists as a component itself. The component wasn't in the original code and it therefore didn't work.
#define variables to store datafiles - for ppt and expt separately.
expInfo['expName']='OOO_visuospatialWM'
processingFilename='data' + os.path.sep + '%s_%s_%s_processing' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
storageFilename='data' + os.path.sep + '%s_%s_%s_storage' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
fp=open(processingFilename+'.csv','w')
fs=open(storageFilename+'.csv','w')
fp_all=open('data' + os.path.sep + 'OOO_visuospatialWM_processing_allParticipants_JE.csv','a')
fs_all=open('data' + os.path.sep + 'OOO_visuospatialWM_storage_allParticipants_JE.csv','a')
fp.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,Response,RT,corrSquare\n')
fs.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,responseSequence,clickSequence,spanCorr,proportionScore,itemsCorr,proportionItemScore\n')
#fp_all.write('\n')
#fs_all.write('\n')
response=0
respSequence=[]
Mouse = event.Mouse(win=win)
x, y = [None, None]
square7 = visual.ImageStim(
    win=win, name='square7',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square8 = visual.ImageStim(
    win=win, name='square8',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square3 = visual.ImageStim(
    win=win, name='square3',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square4 = visual.ImageStim(
    win=win, name='square4',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square5 = visual.ImageStim(
    win=win, name='square5',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square9 = visual.ImageStim(
    win=win, name='square9',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square6 = visual.ImageStim(
    win=win, name='square6',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square1 = visual.ImageStim(
    win=win, name='square1',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
square2 = visual.ImageStim(
    win=win, name='square2',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-10.0)
image1_ = visual.ImageStim(
    win=win, name='image1_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-11.0)
image4_ = visual.ImageStim(
    win=win, name='image4_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-12.0)
image3_ = visual.ImageStim(
    win=win, name='image3_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-13.0)
image2_ = visual.ImageStim(
    win=win, name='image2_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-14.0)

# Initialize components for Routine "Q3"
Q3Clock = core.Clock()
correctCount=0
import time
square4_ = visual.ImageStim(
    win=win, name='square4_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-1.0)
square5_ = visual.ImageStim(
    win=win, name='square5_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square6_ = visual.ImageStim(
    win=win, name='square6_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square7_ = visual.ImageStim(
    win=win, name='square7_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square8_ = visual.ImageStim(
    win=win, name='square8_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square1_ = visual.ImageStim(
    win=win, name='square1_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square2_ = visual.ImageStim(
    win=win, name='square2_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square3_ = visual.ImageStim(
    win=win, name='square3_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square9_ = visual.ImageStim(
    win=win, name='square9_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
text_10 = visual.TextStim(win=win, name='text_10',
    text='?',
    font='Arial',
    pos=[0, 0], height=3.5, wrapWidth=None, ori=0, 
    color='blue', colorSpace='rgb', opacity=1,
    depth=-10.0);

# Initialize components for Routine "pracFeedback_2"
pracFeedback_2Clock = core.Clock()
msg=''
text_23 = visual.TextStim(win=win, name='text_23',
    text='default text',
    font='Arial',
    pos=[0, 3], height=1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "repeatPrac"
repeatPracClock = core.Clock()
text_22 = visual.TextStim(win=win, name='text_22',
    text='Would you like to repeat the practice trials?\n\nPress 1 for Yes \n\nOr press 2 if you would like to start the first game.',
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "spatialInstructions2"
spatialInstructions2Clock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text="Fantastic! Now we're going to do it for real!\n\nWe will begin with a sequence length of 3 items.\n\nPlease find the odd one out and then remember which square it was on.",
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=25, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "presentDot"
presentDotClock = core.Clock()
from psychopy import misc
myMouse=event.Mouse(win=win)#defining the mouse, I'm unsure why as it exists as a component itself. The component wasn't in the original code and it therefore didn't work.
#define variables to store datafiles - for ppt and expt separately.
expInfo['expName']='OOO_visuospatialWM'
processingFilename='data' + os.path.sep + '%s_%s_%s_processing' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
storageFilename='data' + os.path.sep + '%s_%s_%s_storage' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
fp=open(processingFilename+'.csv','w')
fs=open(storageFilename+'.csv','w')
fp_all=open('data' + os.path.sep + 'OOO_visuospatialWM_processing_allParticipants_JE.csv','a')
fs_all=open('data' + os.path.sep + 'OOO_visuospatialWM_storage_allParticipants_JE.csv','a')
fp.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,Response,RT,corrSquare\n')
fs.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,responseSequence,clickSequence,spanCorr,proportionScore,itemsCorr,proportionItemScore\n')
#fp_all.write('\n')
#fs_all.write('\n')
response=0
respSequence=[]
Mouse = event.Mouse(win=win)
x, y = [None, None]
square7 = visual.ImageStim(
    win=win, name='square7',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square8 = visual.ImageStim(
    win=win, name='square8',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square3 = visual.ImageStim(
    win=win, name='square3',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square4 = visual.ImageStim(
    win=win, name='square4',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square5 = visual.ImageStim(
    win=win, name='square5',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square9 = visual.ImageStim(
    win=win, name='square9',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square6 = visual.ImageStim(
    win=win, name='square6',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square1 = visual.ImageStim(
    win=win, name='square1',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
square2 = visual.ImageStim(
    win=win, name='square2',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-10.0)
image1_ = visual.ImageStim(
    win=win, name='image1_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-11.0)
image4_ = visual.ImageStim(
    win=win, name='image4_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-12.0)
image3_ = visual.ImageStim(
    win=win, name='image3_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-13.0)
image2_ = visual.ImageStim(
    win=win, name='image2_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-14.0)

# Initialize components for Routine "Q3"
Q3Clock = core.Clock()
correctCount=0
import time
square4_ = visual.ImageStim(
    win=win, name='square4_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-1.0)
square5_ = visual.ImageStim(
    win=win, name='square5_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square6_ = visual.ImageStim(
    win=win, name='square6_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square7_ = visual.ImageStim(
    win=win, name='square7_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square8_ = visual.ImageStim(
    win=win, name='square8_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square1_ = visual.ImageStim(
    win=win, name='square1_',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square2_ = visual.ImageStim(
    win=win, name='square2_',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square3_ = visual.ImageStim(
    win=win, name='square3_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square9_ = visual.ImageStim(
    win=win, name='square9_',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
text_10 = visual.TextStim(win=win, name='text_10',
    text='?',
    font='Arial',
    pos=[0, 0], height=3.5, wrapWidth=None, ori=0, 
    color='blue', colorSpace='rgb', opacity=1,
    depth=-10.0);

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
feedbackString='greatjob2.jpg'
patch_2 = visual.ImageStim(
    win=win, name='patch_2',
    image='sin', mask=None,
    ori=0, pos=[0, 0], size=[30, 20],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)

# Initialize components for Routine "break_2"
break_2Clock = core.Clock()
text_3 = visual.TextStim(win=win, name='text_3',
    text='Great! try the next one',
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);


# Initialize components for Routine "presentDot"
presentDotClock = core.Clock()
from psychopy import misc
myMouse=event.Mouse(win=win)#defining the mouse, I'm unsure why as it exists as a component itself. The component wasn't in the original code and it therefore didn't work.
#define variables to store datafiles - for ppt and expt separately.
expInfo['expName']='OOO_visuospatialWM'
processingFilename='data' + os.path.sep + '%s_%s_%s_processing' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
storageFilename='data' + os.path.sep + '%s_%s_%s_storage' %(expInfo['participant'], expInfo['date'], expInfo['expName'])
fp=open(processingFilename+'.csv','w')
fs=open(storageFilename+'.csv','w')
fp_all=open('data' + os.path.sep + 'OOO_visuospatialWM_processing_allParticipants_JE.csv','a')
fs_all=open('data' + os.path.sep + 'OOO_visuospatialWM_storage_allParticipants_JE.csv','a')
fp.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,Response,RT,corrSquare\n')
fs.write('Participant,Date,Task,Block,Span,Trial,CorrectAnswer,responseSequence,clickSequence,spanCorr,proportionScore,itemsCorr,proportionItemScore\n')
#fp_all.write('\n')
#fs_all.write('\n')
response=0
respSequence=[]
Mouse = event.Mouse(win=win)
x, y = [None, None]
square7 = visual.ImageStim(
    win=win, name='square7',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-2.0)
square8 = visual.ImageStim(
    win=win, name='square8',
    image='square.jpg', mask=None,
    ori=0, pos=[0, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-3.0)
square3 = visual.ImageStim(
    win=win, name='square3',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-4.0)
square4 = visual.ImageStim(
    win=win, name='square4',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-5.0)
square5 = visual.ImageStim(
    win=win, name='square5',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-6.0)
square9 = visual.ImageStim(
    win=win, name='square9',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, -7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-7.0)
square6 = visual.ImageStim(
    win=win, name='square6',
    image='square.jpg', mask=None,
    ori=0, pos=[7.5, 0], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-8.0)
square1 = visual.ImageStim(
    win=win, name='square1',
    image='square.jpg', mask=None,
    ori=0, pos=[-7.5, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-9.0)
square2 = visual.ImageStim(
    win=win, name='square2',
    image='square.jpg', mask=None,
    ori=0, pos=[0, 7.5], size=[7, 7],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-10.0)
image1_ = visual.ImageStim(
    win=win, name='image1_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-11.0)
image4_ = visual.ImageStim(
    win=win, name='image4_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-12.0)
image3_ = visual.ImageStim(
    win=win, name='image3_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-13.0)
image2_ = visual.ImageStim(
    win=win, name='image2_',
    image='sin', mask=None,
    ori=0, pos=[0,0], size=[4, 4],
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=False, depth=-14.0)

# Initialize components for Routine "Finish"
FinishClock = core.Clock()
text_end = visual.TextStim(win=win, name='text_end',
    text="Well done, you've finished!!\n\n     ",
    font='Arial',
    pos=[0, 0], height=1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# set up handler to look after randomisation of conditions etc
Proc_prac = data.TrialHandler(nReps=0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('ProcessingPracConditionList.xlsx'),
    seed=None, name='Proc_prac')
thisExp.addLoop(Proc_prac)  # add the loop to the experiment
thisProc_prac = Proc_prac.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisProc_prac.rgb)
if thisProc_prac != None:
    for paramName in thisProc_prac.keys():
        exec(paramName + '= thisProc_prac.' + paramName)

for thisProc_prac in Proc_prac:
    currentLoop = Proc_prac
    # abbreviate parameter names if possible (e.g. rgb = thisProc_prac.rgb)
    if thisProc_prac != None:
        for paramName in thisProc_prac.keys():
            exec(paramName + '= thisProc_prac.' + paramName)
    
    # set up handler to look after randomisation of conditions etc
    Processing_prac = data.TrialHandler(nReps=1, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('ProcessingPracConditionList.xlsx'),
        seed=None, name='Processing_prac')
    thisExp.addLoop(Processing_prac)  # add the loop to the experiment
    thisProcessing_prac = Processing_prac.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisProcessing_prac.rgb)
    if thisProcessing_prac != None:
        for paramName in thisProcessing_prac.keys():
            exec(paramName + '= thisProcessing_prac.' + paramName)
    
    for thisProcessing_prac in Processing_prac:
        currentLoop = Processing_prac
        # abbreviate parameter names if possible (e.g. rgb = thisProcessing_prac.rgb)
        if thisProcessing_prac != None:
            for paramName in thisProcessing_prac.keys():
                exec(paramName + '= thisProcessing_prac.' + paramName)
        
        # ------Prepare to start Routine "presentDot"-------
        t = 0
        presentDotClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        # update component parameters for each repeat
        myMouse.setVisible(1)
        myMouse.clickReset()
        clickSequence=[] #empty variable to store the responses (square numbers) that are clicked during the processing routine
        squares=[square1,square2,square3,square4,square5,square6,square7,square8,square9] #list of square numbers as seen on the screen
        
        for square in range(0,9): #I think the range of squares should be  0 - 8. This is the original code (0 to 9) so I've kept it as the original
            squares[square].setSize([7,7])
        
        # setup some python lists for storing info about the Mouse
        image1_.setPos([Loc1x, Loc1y])
        image1_.setImage(image1)
        image4_.setPos([Loc4x, Loc4y])
        image4_.setImage(image4)
        image3_.setPos([Loc3x, Loc3y])
        image3_.setImage(image3)
        image2_.setPos([Loc2x, Loc2y])
        image2_.setImage(image2)
        # keep track of which components have finished
        presentDotComponents = [Mouse, square7, square8, square3, square4, square5, square9, square6, square1, square2, image1_, image4_, image3_, image2_]
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "presentDot"-------
        while continueRoutine:
            # get current time
            t = presentDotClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and add them to two separate lists   
            #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    #this was commented out in the original script so I've left it as it is.
            #event.clearEvents(myMouse)  #again, commented out in the original script so left as it is
            #this set of code below gets details of the location of the mouse where cliked and adds it to a response sequence. The response sequence list is then
            #compared to a recalled sequence in the Q3 routine. 
            if (mouse1):
               mouse_x,mouse_y=myMouse.getPos()
               pix = [mouse_x, mouse_y] #pix is old code. Here we are just storing coordinates of the mouse location
               for square in range(0,9):
                  if squares[square].contains(pix):
                     squares[square].setSize([3,3]) #shrinks the size of the square that was cliked, updates the screen and holds it for half a second
                     win.flip()
                     response=square+1
                     if respSequence==[]:  #always true on the first click           
                        respSequence.append(response)          
                     elif response<>respSequence[-1]:  #<> is old python way of saying 'not equal' - if it's not equal to an empty list?           
                        respSequence.append(response)             
                     core.wait(0.5)
                     continueRoutine=False
            
            
            
            
            # *square7* updates
            if t >= 0.5 and square7.status == NOT_STARTED:
                # keep track of start time/frame for later
                square7.tStart = t
                square7.frameNStart = frameN  # exact frame index
                square7.setAutoDraw(True)
            
            # *square8* updates
            if t >= 0.5 and square8.status == NOT_STARTED:
                # keep track of start time/frame for later
                square8.tStart = t
                square8.frameNStart = frameN  # exact frame index
                square8.setAutoDraw(True)
            
            # *square3* updates
            if t >= 0.5 and square3.status == NOT_STARTED:
                # keep track of start time/frame for later
                square3.tStart = t
                square3.frameNStart = frameN  # exact frame index
                square3.setAutoDraw(True)
            
            # *square4* updates
            if t >= 0.5 and square4.status == NOT_STARTED:
                # keep track of start time/frame for later
                square4.tStart = t
                square4.frameNStart = frameN  # exact frame index
                square4.setAutoDraw(True)
            
            # *square5* updates
            if t >= 0.5 and square5.status == NOT_STARTED:
                # keep track of start time/frame for later
                square5.tStart = t
                square5.frameNStart = frameN  # exact frame index
                square5.setAutoDraw(True)
            
            # *square9* updates
            if t >= 0.5 and square9.status == NOT_STARTED:
                # keep track of start time/frame for later
                square9.tStart = t
                square9.frameNStart = frameN  # exact frame index
                square9.setAutoDraw(True)
            
            # *square6* updates
            if t >= 0.5 and square6.status == NOT_STARTED:
                # keep track of start time/frame for later
                square6.tStart = t
                square6.frameNStart = frameN  # exact frame index
                square6.setAutoDraw(True)
            
            # *square1* updates
            if t >= 0.5 and square1.status == NOT_STARTED:
                # keep track of start time/frame for later
                square1.tStart = t
                square1.frameNStart = frameN  # exact frame index
                square1.setAutoDraw(True)
            
            # *square2* updates
            if t >= 0.5 and square2.status == NOT_STARTED:
                # keep track of start time/frame for later
                square2.tStart = t
                square2.frameNStart = frameN  # exact frame index
                square2.setAutoDraw(True)
            
            # *image1_* updates
            if t >= 0.5 and image1_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image1_.tStart = t
                image1_.frameNStart = frameN  # exact frame index
                image1_.setAutoDraw(True)
            
            # *image4_* updates
            if t >= 0.5 and image4_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image4_.tStart = t
                image4_.frameNStart = frameN  # exact frame index
                image4_.setAutoDraw(True)
            
            # *image3_* updates
            if t >= 0.5 and image3_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image3_.tStart = t
                image3_.frameNStart = frameN  # exact frame index
                image3_.setAutoDraw(True)
            
            # *image2_* updates
            if t >= 0.5 and image2_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image2_.tStart = t
                image2_.frameNStart = frameN  # exact frame index
                image2_.setAutoDraw(True)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in presentDotComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "presentDot"-------
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        myMouse.setVisible(0)
        if str(response)==str(corrAns): # was the square that was clicked actually the odd one out?
            corrSquare=1
        else:
            corrSquare=0
        currentLoop.addData('response',response)
        currentLoop.addData('corrSquare',corrSquare)
        fp.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        fp_all.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        
        event.clearEvents()
        # store data for Processing_prac (TrialHandler)
        x, y = Mouse.getPos()
        buttons = Mouse.getPressed()
        Processing_prac.addData('Mouse.x', x)
        Processing_prac.addData('Mouse.y', y)
        Processing_prac.addData('Mouse.leftButton', buttons[0])
        Processing_prac.addData('Mouse.midButton', buttons[1])
        Processing_prac.addData('Mouse.rightButton', buttons[2])
        # the Routine "presentDot" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 1 repeats of 'Processing_prac'
    
    # get names of stimulus parameters
    if Processing_prac.trialList in ([], [None], None):
        params = []
    else:
        params = Processing_prac.trialList[0].keys()
    # save data for this loop
    Processing_prac.saveAsExcel(filename + '.xlsx', sheetName='Processing_prac',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "RepeatPrac"-------
    t = 0
    RepeatPracClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    
    key_resp_4 = event.BuilderKeyResponse()
    # keep track of which components have finished
    RepeatPracComponents = [text_5, key_resp_4]
    for thisComponent in RepeatPracComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "RepeatPrac"-------
    while continueRoutine:
        # get current time
        t = RepeatPracClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        
        # *text_5* updates
        if t >= 0.0 and text_5.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_5.tStart = t
            text_5.frameNStart = frameN  # exact frame index
            text_5.setAutoDraw(True)
        
        # *key_resp_4* updates
        if t >= 0.0 and key_resp_4.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_4.tStart = t
            key_resp_4.frameNStart = frameN  # exact frame index
            key_resp_4.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(key_resp_4.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if key_resp_4.status == STARTED:
            theseKeys = event.getKeys(keyList=['num_1', 'num_2', 'num_3'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                key_resp_4.keys = theseKeys[-1]  # just the last key pressed
                key_resp_4.rt = key_resp_4.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in RepeatPracComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "RepeatPrac"-------
    for thisComponent in RepeatPracComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    if key_resp_4.keys=='num_2':
        Proc_prac.finished=True
    elif key_resp_4.keys=='num_3':
        core.quit()
    # check responses
    if key_resp_4.keys in ['', [], None]:  # No response was made
        key_resp_4.keys=None
    Proc_prac.addData('key_resp_4.keys',key_resp_4.keys)
    if key_resp_4.keys != None:  # we had a response
        Proc_prac.addData('key_resp_4.rt', key_resp_4.rt)
    # the Routine "RepeatPrac" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 0 repeats of 'Proc_prac'

# get names of stimulus parameters
if Proc_prac.trialList in ([], [None], None):
    params = []
else:
    params = Proc_prac.trialList[0].keys()
# save data for this loop
Proc_prac.saveAsExcel(filename + '.xlsx', sheetName='Proc_prac',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# set up handler to look after randomisation of conditions etc
Processing_loop = data.TrialHandler(nReps=0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('ProcessingConditionList.xlsx'),
    seed=None, name='Processing_loop')
thisExp.addLoop(Processing_loop)  # add the loop to the experiment
thisProcessing_loop = Processing_loop.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisProcessing_loop.rgb)
if thisProcessing_loop != None:
    for paramName in thisProcessing_loop.keys():
        exec(paramName + '= thisProcessing_loop.' + paramName)

for thisProcessing_loop in Processing_loop:
    currentLoop = Processing_loop
    # abbreviate parameter names if possible (e.g. rgb = thisProcessing_loop.rgb)
    if thisProcessing_loop != None:
        for paramName in thisProcessing_loop.keys():
            exec(paramName + '= thisProcessing_loop.' + paramName)
    
    # ------Prepare to start Routine "presentDot"-------
    t = 0
    presentDotClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    myMouse.setVisible(1)
    myMouse.clickReset()
    clickSequence=[] #empty variable to store the responses (square numbers) that are clicked during the processing routine
    squares=[square1,square2,square3,square4,square5,square6,square7,square8,square9] #list of square numbers as seen on the screen
    
    for square in range(0,9): #I think the range of squares should be  0 - 8. This is the original code (0 to 9) so I've kept it as the original
        squares[square].setSize([7,7])
    
    # setup some python lists for storing info about the Mouse
    image1_.setPos([Loc1x, Loc1y])
    image1_.setImage(image1)
    image4_.setPos([Loc4x, Loc4y])
    image4_.setImage(image4)
    image3_.setPos([Loc3x, Loc3y])
    image3_.setImage(image3)
    image2_.setPos([Loc2x, Loc2y])
    image2_.setImage(image2)
    # keep track of which components have finished
    presentDotComponents = [Mouse, square7, square8, square3, square4, square5, square9, square6, square1, square2, image1_, image4_, image3_, image2_]
    for thisComponent in presentDotComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "presentDot"-------
    while continueRoutine:
        # get current time
        t = presentDotClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and add them to two separate lists   
        #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    #this was commented out in the original script so I've left it as it is.
        #event.clearEvents(myMouse)  #again, commented out in the original script so left as it is
        #this set of code below gets details of the location of the mouse where cliked and adds it to a response sequence. The response sequence list is then
        #compared to a recalled sequence in the Q3 routine. 
        if (mouse1):
           mouse_x,mouse_y=myMouse.getPos()
           pix = [mouse_x, mouse_y] #pix is old code. Here we are just storing coordinates of the mouse location
           for square in range(0,9):
              if squares[square].contains(pix):
                 squares[square].setSize([3,3]) #shrinks the size of the square that was cliked, updates the screen and holds it for half a second
                 win.flip()
                 response=square+1
                 if respSequence==[]:  #always true on the first click           
                    respSequence.append(response)          
                 elif response<>respSequence[-1]:  #<> is old python way of saying 'not equal' - if it's not equal to an empty list?           
                    respSequence.append(response)             
                 core.wait(0.5)
                 continueRoutine=False
        
        
        
        
        # *square7* updates
        if t >= 0.5 and square7.status == NOT_STARTED:
            # keep track of start time/frame for later
            square7.tStart = t
            square7.frameNStart = frameN  # exact frame index
            square7.setAutoDraw(True)
        
        # *square8* updates
        if t >= 0.5 and square8.status == NOT_STARTED:
            # keep track of start time/frame for later
            square8.tStart = t
            square8.frameNStart = frameN  # exact frame index
            square8.setAutoDraw(True)
        
        # *square3* updates
        if t >= 0.5 and square3.status == NOT_STARTED:
            # keep track of start time/frame for later
            square3.tStart = t
            square3.frameNStart = frameN  # exact frame index
            square3.setAutoDraw(True)
        
        # *square4* updates
        if t >= 0.5 and square4.status == NOT_STARTED:
            # keep track of start time/frame for later
            square4.tStart = t
            square4.frameNStart = frameN  # exact frame index
            square4.setAutoDraw(True)
        
        # *square5* updates
        if t >= 0.5 and square5.status == NOT_STARTED:
            # keep track of start time/frame for later
            square5.tStart = t
            square5.frameNStart = frameN  # exact frame index
            square5.setAutoDraw(True)
        
        # *square9* updates
        if t >= 0.5 and square9.status == NOT_STARTED:
            # keep track of start time/frame for later
            square9.tStart = t
            square9.frameNStart = frameN  # exact frame index
            square9.setAutoDraw(True)
        
        # *square6* updates
        if t >= 0.5 and square6.status == NOT_STARTED:
            # keep track of start time/frame for later
            square6.tStart = t
            square6.frameNStart = frameN  # exact frame index
            square6.setAutoDraw(True)
        
        # *square1* updates
        if t >= 0.5 and square1.status == NOT_STARTED:
            # keep track of start time/frame for later
            square1.tStart = t
            square1.frameNStart = frameN  # exact frame index
            square1.setAutoDraw(True)
        
        # *square2* updates
        if t >= 0.5 and square2.status == NOT_STARTED:
            # keep track of start time/frame for later
            square2.tStart = t
            square2.frameNStart = frameN  # exact frame index
            square2.setAutoDraw(True)
        
        # *image1_* updates
        if t >= 0.5 and image1_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image1_.tStart = t
            image1_.frameNStart = frameN  # exact frame index
            image1_.setAutoDraw(True)
        
        # *image4_* updates
        if t >= 0.5 and image4_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image4_.tStart = t
            image4_.frameNStart = frameN  # exact frame index
            image4_.setAutoDraw(True)
        
        # *image3_* updates
        if t >= 0.5 and image3_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image3_.tStart = t
            image3_.frameNStart = frameN  # exact frame index
            image3_.setAutoDraw(True)
        
        # *image2_* updates
        if t >= 0.5 and image2_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image2_.tStart = t
            image2_.frameNStart = frameN  # exact frame index
            image2_.setAutoDraw(True)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "presentDot"-------
    for thisComponent in presentDotComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    myMouse.setVisible(0)
    if str(response)==str(corrAns): # was the square that was clicked actually the odd one out?
        corrSquare=1
    else:
        corrSquare=0
    currentLoop.addData('response',response)
    currentLoop.addData('corrSquare',corrSquare)
    fp.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
    fp_all.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
    
    event.clearEvents()
    # store data for Processing_loop (TrialHandler)
    x, y = Mouse.getPos()
    buttons = Mouse.getPressed()
    Processing_loop.addData('Mouse.x', x)
    Processing_loop.addData('Mouse.y', y)
    Processing_loop.addData('Mouse.leftButton', buttons[0])
    Processing_loop.addData('Mouse.midButton', buttons[1])
    Processing_loop.addData('Mouse.rightButton', buttons[2])
    # the Routine "presentDot" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 0 repeats of 'Processing_loop'

# get names of stimulus parameters
if Processing_loop.trialList in ([], [None], None):
    params = []
else:
    params = Processing_loop.trialList[0].keys()
# save data for this loop
Processing_loop.saveAsExcel(filename + '.xlsx', sheetName='Processing_loop',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "Instruc_"-------
t = 0
Instruc_Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_22 = event.BuilderKeyResponse()
respSequence=[]
# keep track of which components have finished
Instruc_Components = [text_20, key_resp_22]
for thisComponent in Instruc_Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instruc_"-------
while continueRoutine:
    # get current time
    t = Instruc_Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_20* updates
    if t >= 0.0 and text_20.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_20.tStart = t
        text_20.frameNStart = frameN  # exact frame index
        text_20.setAutoDraw(True)
    
    # *key_resp_22* updates
    if t >= 0.0 and key_resp_22.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_22.tStart = t
        key_resp_22.frameNStart = frameN  # exact frame index
        key_resp_22.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_22.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_22.status == STARTED:
        theseKeys = event.getKeys(keyList=['return'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_22.keys = theseKeys[-1]  # just the last key pressed
            key_resp_22.rt = key_resp_22.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Instruc_Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instruc_"-------
for thisComponent in Instruc_Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_22.keys in ['', [], None]:  # No response was made
    key_resp_22.keys=None
thisExp.addData('key_resp_22.keys',key_resp_22.keys)
if key_resp_22.keys != None:  # we had a response
    thisExp.addData('key_resp_22.rt', key_resp_22.rt)
thisExp.nextEntry()

# the Routine "Instruc_" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
spatialspanprac = data.TrialHandler(nReps=3, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('SpatialSpanPracConditions.xlsx'),
    seed=None, name='spatialspanprac')
thisExp.addLoop(spatialspanprac)  # add the loop to the experiment
thisSpatialspanprac = spatialspanprac.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisSpatialspanprac.rgb)
if thisSpatialspanprac != None:
    for paramName in thisSpatialspanprac.keys():
        exec(paramName + '= thisSpatialspanprac.' + paramName)

for thisSpatialspanprac in spatialspanprac:
    currentLoop = spatialspanprac
    # abbreviate parameter names if possible (e.g. rgb = thisSpatialspanprac.rgb)
    if thisSpatialspanprac != None:
        for paramName in thisSpatialspanprac.keys():
            exec(paramName + '= thisSpatialspanprac.' + paramName)
    
    # set up handler to look after randomisation of conditions etc
    presentDotPracLoop = data.TrialHandler(nReps=1, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(SpatialSpanPracConditions),
        seed=None, name='presentDotPracLoop')
    thisExp.addLoop(presentDotPracLoop)  # add the loop to the experiment
    thisPresentDotPracLoop = presentDotPracLoop.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisPresentDotPracLoop.rgb)
    if thisPresentDotPracLoop != None:
        for paramName in thisPresentDotPracLoop.keys():
            exec(paramName + '= thisPresentDotPracLoop.' + paramName)
    
    for thisPresentDotPracLoop in presentDotPracLoop:
        currentLoop = presentDotPracLoop
        # abbreviate parameter names if possible (e.g. rgb = thisPresentDotPracLoop.rgb)
        if thisPresentDotPracLoop != None:
            for paramName in thisPresentDotPracLoop.keys():
                exec(paramName + '= thisPresentDotPracLoop.' + paramName)
        
        # ------Prepare to start Routine "presentDot"-------
        t = 0
        presentDotClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        # update component parameters for each repeat
        myMouse.setVisible(1)
        myMouse.clickReset()
        clickSequence=[] #empty variable to store the responses (square numbers) that are clicked during the processing routine
        squares=[square1,square2,square3,square4,square5,square6,square7,square8,square9] #list of square numbers as seen on the screen
        
        for square in range(0,9): #I think the range of squares should be  0 - 8. This is the original code (0 to 9) so I've kept it as the original
            squares[square].setSize([7,7])
        
        # setup some python lists for storing info about the Mouse
        image1_.setPos([Loc1x, Loc1y])
        image1_.setImage(image1)
        image4_.setPos([Loc4x, Loc4y])
        image4_.setImage(image4)
        image3_.setPos([Loc3x, Loc3y])
        image3_.setImage(image3)
        image2_.setPos([Loc2x, Loc2y])
        image2_.setImage(image2)
        # keep track of which components have finished
        presentDotComponents = [Mouse, square7, square8, square3, square4, square5, square9, square6, square1, square2, image1_, image4_, image3_, image2_]
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "presentDot"-------
        while continueRoutine:
            # get current time
            t = presentDotClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and add them to two separate lists   
            #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    #this was commented out in the original script so I've left it as it is.
            #event.clearEvents(myMouse)  #again, commented out in the original script so left as it is
            #this set of code below gets details of the location of the mouse where cliked and adds it to a response sequence. The response sequence list is then
            #compared to a recalled sequence in the Q3 routine. 
            if (mouse1):
               mouse_x,mouse_y=myMouse.getPos()
               pix = [mouse_x, mouse_y] #pix is old code. Here we are just storing coordinates of the mouse location
               for square in range(0,9):
                  if squares[square].contains(pix):
                     squares[square].setSize([3,3]) #shrinks the size of the square that was cliked, updates the screen and holds it for half a second
                     win.flip()
                     response=square+1
                     if respSequence==[]:  #always true on the first click           
                        respSequence.append(response)          
                     elif response<>respSequence[-1]:  #<> is old python way of saying 'not equal' - if it's not equal to an empty list?           
                        respSequence.append(response)             
                     core.wait(0.5)
                     continueRoutine=False
            
            
            
            
            # *square7* updates
            if t >= 0.5 and square7.status == NOT_STARTED:
                # keep track of start time/frame for later
                square7.tStart = t
                square7.frameNStart = frameN  # exact frame index
                square7.setAutoDraw(True)
            
            # *square8* updates
            if t >= 0.5 and square8.status == NOT_STARTED:
                # keep track of start time/frame for later
                square8.tStart = t
                square8.frameNStart = frameN  # exact frame index
                square8.setAutoDraw(True)
            
            # *square3* updates
            if t >= 0.5 and square3.status == NOT_STARTED:
                # keep track of start time/frame for later
                square3.tStart = t
                square3.frameNStart = frameN  # exact frame index
                square3.setAutoDraw(True)
            
            # *square4* updates
            if t >= 0.5 and square4.status == NOT_STARTED:
                # keep track of start time/frame for later
                square4.tStart = t
                square4.frameNStart = frameN  # exact frame index
                square4.setAutoDraw(True)
            
            # *square5* updates
            if t >= 0.5 and square5.status == NOT_STARTED:
                # keep track of start time/frame for later
                square5.tStart = t
                square5.frameNStart = frameN  # exact frame index
                square5.setAutoDraw(True)
            
            # *square9* updates
            if t >= 0.5 and square9.status == NOT_STARTED:
                # keep track of start time/frame for later
                square9.tStart = t
                square9.frameNStart = frameN  # exact frame index
                square9.setAutoDraw(True)
            
            # *square6* updates
            if t >= 0.5 and square6.status == NOT_STARTED:
                # keep track of start time/frame for later
                square6.tStart = t
                square6.frameNStart = frameN  # exact frame index
                square6.setAutoDraw(True)
            
            # *square1* updates
            if t >= 0.5 and square1.status == NOT_STARTED:
                # keep track of start time/frame for later
                square1.tStart = t
                square1.frameNStart = frameN  # exact frame index
                square1.setAutoDraw(True)
            
            # *square2* updates
            if t >= 0.5 and square2.status == NOT_STARTED:
                # keep track of start time/frame for later
                square2.tStart = t
                square2.frameNStart = frameN  # exact frame index
                square2.setAutoDraw(True)
            
            # *image1_* updates
            if t >= 0.5 and image1_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image1_.tStart = t
                image1_.frameNStart = frameN  # exact frame index
                image1_.setAutoDraw(True)
            
            # *image4_* updates
            if t >= 0.5 and image4_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image4_.tStart = t
                image4_.frameNStart = frameN  # exact frame index
                image4_.setAutoDraw(True)
            
            # *image3_* updates
            if t >= 0.5 and image3_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image3_.tStart = t
                image3_.frameNStart = frameN  # exact frame index
                image3_.setAutoDraw(True)
            
            # *image2_* updates
            if t >= 0.5 and image2_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image2_.tStart = t
                image2_.frameNStart = frameN  # exact frame index
                image2_.setAutoDraw(True)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in presentDotComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "presentDot"-------
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        myMouse.setVisible(0)
        if str(response)==str(corrAns): # was the square that was clicked actually the odd one out?
            corrSquare=1
        else:
            corrSquare=0
        currentLoop.addData('response',response)
        currentLoop.addData('corrSquare',corrSquare)
        fp.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        fp_all.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        
        event.clearEvents()
        # store data for presentDotPracLoop (TrialHandler)
        x, y = Mouse.getPos()
        buttons = Mouse.getPressed()
        presentDotPracLoop.addData('Mouse.x', x)
        presentDotPracLoop.addData('Mouse.y', y)
        presentDotPracLoop.addData('Mouse.leftButton', buttons[0])
        presentDotPracLoop.addData('Mouse.midButton', buttons[1])
        presentDotPracLoop.addData('Mouse.rightButton', buttons[2])
        # the Routine "presentDot" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 1 repeats of 'presentDotPracLoop'
    
    # get names of stimulus parameters
    if presentDotPracLoop.trialList in ([], [None], None):
        params = []
    else:
        params = presentDotPracLoop.trialList[0].keys()
    # save data for this loop
    presentDotPracLoop.saveAsExcel(filename + '.xlsx', sheetName='presentDotPracLoop',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "Q3"-------
    t = 0
    Q3Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    myMouse.setVisible(1) # This defines the mouse component, which is not visible in the builder view of the routine
    myMouse.clickReset() # Reset all attributes of the mouse at the start of the routine
    clickSequence=[] # empty list for storing the square numbers as items
    squares=[square1_,square2_,square3_,square4_,square5_,square6_,square7_,square8_,square9_] #a list of squares
    for square in range(0,9):   # I think this should be a range of 0,8 not 0,9?  
        squares[square].setSize([7,7]) #sets the size of the squares relative to the display
    
    # keep track of which components have finished
    Q3Components = [square4_, square5_, square6_, square7_, square8_, square1_, square2_, square3_, square9_, text_10]
    for thisComponent in Q3Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "Q3"-------
    while continueRoutine:
        # get current time
        t = Q3Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and store them as two lists 
        ##These next two lines were commented out, but not by JE##   
        #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    
        #event.clearEvents(myMouse)   
        if (mouse1):# if the first mouse button is pressed    
            mouse_x,mouse_y=myMouse.getPos()# assign the coordinates to variables    
            pix = [mouse_x, mouse_y]    #store the variables in a list. Originally, the code was based on an old version of Psychopy, where coordinates needed tp be converted to pixels. In the newer version this does not need to be done, Coordinates can be compared to other coordinates
            for square in range(0,9):    # evaluate the position of the mouse for all of the squares   
                if squares[square].contains(pix):#the next 3 lines of code originally shrunk the size of the squares, but it didn't work for the final click. I've now fixed it so it works.
                    squares[square].setSize([3,3])
                    win.flip()
                    core.wait(0.5)
                    if clickSequence==[]:#always true on the first trial
                        clickSequence.append(square+1) #add the number of the current square, plus 1 (number of squares starts at 0)
                    elif square+1<>clickSequence[-1]:  #if it doesn't equal, in old python language - so if it doesn't equal an empty list           
                        clickSequence.append(square+1)
                    if len(clickSequence)==len(respSequence): #when the number of clicks equals the number of expected clicks, end the routine
                            continueRoutine=False
                            event.clearEvents()    
        
        
        
        
        # *square4_* updates
        if t >= 0.0 and square4_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square4_.tStart = t
            square4_.frameNStart = frameN  # exact frame index
            square4_.setAutoDraw(True)
        
        # *square5_* updates
        if t >= 0.0 and square5_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square5_.tStart = t
            square5_.frameNStart = frameN  # exact frame index
            square5_.setAutoDraw(True)
        
        # *square6_* updates
        if t >= 0.0 and square6_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square6_.tStart = t
            square6_.frameNStart = frameN  # exact frame index
            square6_.setAutoDraw(True)
        
        # *square7_* updates
        if t >= 0.0 and square7_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square7_.tStart = t
            square7_.frameNStart = frameN  # exact frame index
            square7_.setAutoDraw(True)
        
        # *square8_* updates
        if t >= 0.0 and square8_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square8_.tStart = t
            square8_.frameNStart = frameN  # exact frame index
            square8_.setAutoDraw(True)
        
        # *square1_* updates
        if t >= 0.0 and square1_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square1_.tStart = t
            square1_.frameNStart = frameN  # exact frame index
            square1_.setAutoDraw(True)
        
        # *square2_* updates
        if t >= 0.0 and square2_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square2_.tStart = t
            square2_.frameNStart = frameN  # exact frame index
            square2_.setAutoDraw(True)
        
        # *square3_* updates
        if t >= 0.0 and square3_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square3_.tStart = t
            square3_.frameNStart = frameN  # exact frame index
            square3_.setAutoDraw(True)
        
        # *square9_* updates
        if t >= 0.0 and square9_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square9_.tStart = t
            square9_.frameNStart = frameN  # exact frame index
            square9_.setAutoDraw(True)
        
        # *text_10* updates
        if t >= 0.5 and text_10.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_10.tStart = t
            text_10.frameNStart = frameN  # exact frame index
            text_10.setAutoDraw(True)
        frameRemains = 0.5 + 1.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if text_10.status == STARTED and t >= frameRemains:
            text_10.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in Q3Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "Q3"-------
    for thisComponent in Q3Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # I think this code does the scoring. It scores largely two things - 1) The number of times the items in each set were recalled in order to what was pressed in the processing phase.
    # and 2) The number of items recalled regardless of the order, of the items cliked on in the processing phase. e.g. span score and proportion score do factor in
    # whether the order was correct, while item score and proportionitemscore do not factor in whether the order was correct.
    if clickSequence==respSequence: #if the squares that were clicked on in processing were equal to the squares clicked on during recall, it is correct (note the comparson is between what is cliked on in the processing, regardless of whether that processing click itself was correct - i.e. the odd one, or not.
      spanCorr=1
      correctCount=correctCount+1
    else:
      spanCorr=0
    
    #determine if all items recalled, item doesn't matter 
    if list(set(clickSequence))==list(set(respSequence)):   #convert the lists into sets and compare them, ignoring the order  
        itemCorr=1 
    else:     
        itemCorr=0  
    
    #calculate proportion score
    #I think it calculates two proportions. The first is the number of items recalled in the correct position
    #'recallcount'. The second is the number of items recalled, regarldess of their order, 'item count'
    recallCount=0 
    itemCount=0
    for i in range(len(clickSequence)):     
        if clickSequence[i]==respSequence[i]:         
            recallCount=recallCount+1 
        if clickSequence[i] in respSequence:
            itemCount=itemCount+1
    if recallCount>0:     
        proportionScore=recallCount/len(respSequence) 
    else:     
        proportionScore=0       
    
    if itemCount>0:     
        proportionItemScore=itemCount/len(respSequence) 
    else:     
        proportionItemScore=0      
    
    currentLoop.addData('spanCorr',spanCorr)
    currentLoop.addData('clickSequence',clickSequence)
    currentLoop.addData('respSequence',respSequence)
    
    fs.write('%s,%s,%s,%s,%s,%s,"%s","%s","%s",%i,%.02f,%i,%.02f\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,spatialCorrectAnswer,respSequence,clickSequence,spanCorr,proportionScore,itemCorr,proportionItemScore)) #needs adding to so adds all data to each row
    fs_all.write('%s,%s,%s,%s,%s,%s,"%s","%s","%s",%i,%.02f,%i,%.02f\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,spatialCorrectAnswer,respSequence,clickSequence,spanCorr,proportionScore,itemCorr,proportionItemScore)) #needs adding to so adds all data to each row
    
    respSequence=[]
    # the Routine "Q3" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "pracFeedback_2"-------
    t = 0
    pracFeedback_2Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(1.000000)
    # update component parameters for each repeat
    #give feedback
    if spanCorr==1:
      msg='Well done!'
    else:
      msg='Oh dear, lets try another one'
    text_23.setText(msg)
    # keep track of which components have finished
    pracFeedback_2Components = [text_23]
    for thisComponent in pracFeedback_2Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "pracFeedback_2"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = pracFeedback_2Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        
        # *text_23* updates
        if t >= 0.0 and text_23.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_23.tStart = t
            text_23.frameNStart = frameN  # exact frame index
            text_23.setAutoDraw(True)
        frameRemains = 0.0 + 1- win.monitorFramePeriod * 0.75  # most of one frame period left
        if text_23.status == STARTED and t >= frameRemains:
            text_23.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in pracFeedback_2Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "pracFeedback_2"-------
    for thisComponent in pracFeedback_2Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    
    # ------Prepare to start Routine "repeatPrac"-------
    t = 0
    repeatPracClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_24 = event.BuilderKeyResponse()
    
    # keep track of which components have finished
    repeatPracComponents = [text_22, key_resp_24]
    for thisComponent in repeatPracComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "repeatPrac"-------
    while continueRoutine:
        # get current time
        t = repeatPracClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_22* updates
        if t >= 0.0 and text_22.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_22.tStart = t
            text_22.frameNStart = frameN  # exact frame index
            text_22.setAutoDraw(True)
        
        # *key_resp_24* updates
        if t >= 0.0 and key_resp_24.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_24.tStart = t
            key_resp_24.frameNStart = frameN  # exact frame index
            key_resp_24.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(key_resp_24.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if key_resp_24.status == STARTED:
            theseKeys = event.getKeys(keyList=['num_1', 'num_2', 'num_3'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                key_resp_24.keys = theseKeys[-1]  # just the last key pressed
                key_resp_24.rt = key_resp_24.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        #spatialspan starts with a trial number of 0
        if (spatialspanprac.thisTrialN!=2):
          continueRoutine=False
        
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in repeatPracComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "repeatPrac"-------
    for thisComponent in repeatPracComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_resp_24.keys in ['', [], None]:  # No response was made
        key_resp_24.keys=None
    spatialspanprac.addData('key_resp_24.keys',key_resp_24.keys)
    if key_resp_24.keys != None:  # we had a response
        spatialspanprac.addData('key_resp_24.rt', key_resp_24.rt)
    #If 3 is pressed, don't continue
    #If 2 is pressed, continue to main trials.
    #If 1 is pressed, continue in the existing loop (practice trials can be repeated/completed up to 3 times)
    
    if key_resp_24.keys =='num_2':
        print 'check1'
        spatialspanprac.finished=True
    elif key_resp_24.keys=='num_3':
        core.quit()
    # the Routine "repeatPrac" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 3 repeats of 'spatialspanprac'

# get names of stimulus parameters
if spatialspanprac.trialList in ([], [None], None):
    params = []
else:
    params = spatialspanprac.trialList[0].keys()
# save data for this loop
spatialspanprac.saveAsExcel(filename + '.xlsx', sheetName='spatialspanprac',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "spatialInstructions2"-------
t = 0
spatialInstructions2Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_18 = event.BuilderKeyResponse()
correctCount=0
# keep track of which components have finished
spatialInstructions2Components = [text_19, key_resp_18]
for thisComponent in spatialInstructions2Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "spatialInstructions2"-------
while continueRoutine:
    # get current time
    t = spatialInstructions2Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_19* updates
    if t >= 0.5 and text_19.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_19.tStart = t
        text_19.frameNStart = frameN  # exact frame index
        text_19.setAutoDraw(True)
    
    # *key_resp_18* updates
    if t >= 0.5 and key_resp_18.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_18.tStart = t
        key_resp_18.frameNStart = frameN  # exact frame index
        key_resp_18.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if key_resp_18.status == STARTED:
        theseKeys = event.getKeys(keyList=['return'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in spatialInstructions2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "spatialInstructions2"-------
for thisComponent in spatialInstructions2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# the Routine "spatialInstructions2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
spatialspan = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('SpatialSpanConditions.xlsx'),
    seed=None, name='spatialspan')
thisExp.addLoop(spatialspan)  # add the loop to the experiment
thisSpatialspan = spatialspan.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisSpatialspan.rgb)
if thisSpatialspan != None:
    for paramName in thisSpatialspan.keys():
        exec(paramName + '= thisSpatialspan.' + paramName)

for thisSpatialspan in spatialspan:
    currentLoop = spatialspan
    # abbreviate parameter names if possible (e.g. rgb = thisSpatialspan.rgb)
    if thisSpatialspan != None:
        for paramName in thisSpatialspan.keys():
            exec(paramName + '= thisSpatialspan.' + paramName)
    
    # set up handler to look after randomisation of conditions etc
    spatialspan2 = data.TrialHandler(nReps=1, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(SpatialSpanConditions),
        seed=None, name='spatialspan2')
    thisExp.addLoop(spatialspan2)  # add the loop to the experiment
    thisSpatialspan2 = spatialspan2.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisSpatialspan2.rgb)
    if thisSpatialspan2 != None:
        for paramName in thisSpatialspan2.keys():
            exec(paramName + '= thisSpatialspan2.' + paramName)
    
    for thisSpatialspan2 in spatialspan2:
        currentLoop = spatialspan2
        # abbreviate parameter names if possible (e.g. rgb = thisSpatialspan2.rgb)
        if thisSpatialspan2 != None:
            for paramName in thisSpatialspan2.keys():
                exec(paramName + '= thisSpatialspan2.' + paramName)
        
        # ------Prepare to start Routine "presentDot"-------
        t = 0
        presentDotClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        # update component parameters for each repeat
        myMouse.setVisible(1)
        myMouse.clickReset()
        clickSequence=[] #empty variable to store the responses (square numbers) that are clicked during the processing routine
        squares=[square1,square2,square3,square4,square5,square6,square7,square8,square9] #list of square numbers as seen on the screen
        
        for square in range(0,9): #I think the range of squares should be  0 - 8. This is the original code (0 to 9) so I've kept it as the original
            squares[square].setSize([7,7])
        
        # setup some python lists for storing info about the Mouse
        image1_.setPos([Loc1x, Loc1y])
        image1_.setImage(image1)
        image4_.setPos([Loc4x, Loc4y])
        image4_.setImage(image4)
        image3_.setPos([Loc3x, Loc3y])
        image3_.setImage(image3)
        image2_.setPos([Loc2x, Loc2y])
        image2_.setImage(image2)
        # keep track of which components have finished
        presentDotComponents = [Mouse, square7, square8, square3, square4, square5, square9, square6, square1, square2, image1_, image4_, image3_, image2_]
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "presentDot"-------
        while continueRoutine:
            # get current time
            t = presentDotClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and add them to two separate lists   
            #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    #this was commented out in the original script so I've left it as it is.
            #event.clearEvents(myMouse)  #again, commented out in the original script so left as it is
            #this set of code below gets details of the location of the mouse where cliked and adds it to a response sequence. The response sequence list is then
            #compared to a recalled sequence in the Q3 routine. 
            if (mouse1):
               mouse_x,mouse_y=myMouse.getPos()
               pix = [mouse_x, mouse_y] #pix is old code. Here we are just storing coordinates of the mouse location
               for square in range(0,9):
                  if squares[square].contains(pix):
                     squares[square].setSize([3,3]) #shrinks the size of the square that was cliked, updates the screen and holds it for half a second
                     win.flip()
                     response=square+1
                     if respSequence==[]:  #always true on the first click           
                        respSequence.append(response)          
                     elif response<>respSequence[-1]:  #<> is old python way of saying 'not equal' - if it's not equal to an empty list?           
                        respSequence.append(response)             
                     core.wait(0.5)
                     continueRoutine=False
            
            
            
            
            # *square7* updates
            if t >= 0.5 and square7.status == NOT_STARTED:
                # keep track of start time/frame for later
                square7.tStart = t
                square7.frameNStart = frameN  # exact frame index
                square7.setAutoDraw(True)
            
            # *square8* updates
            if t >= 0.5 and square8.status == NOT_STARTED:
                # keep track of start time/frame for later
                square8.tStart = t
                square8.frameNStart = frameN  # exact frame index
                square8.setAutoDraw(True)
            
            # *square3* updates
            if t >= 0.5 and square3.status == NOT_STARTED:
                # keep track of start time/frame for later
                square3.tStart = t
                square3.frameNStart = frameN  # exact frame index
                square3.setAutoDraw(True)
            
            # *square4* updates
            if t >= 0.5 and square4.status == NOT_STARTED:
                # keep track of start time/frame for later
                square4.tStart = t
                square4.frameNStart = frameN  # exact frame index
                square4.setAutoDraw(True)
            
            # *square5* updates
            if t >= 0.5 and square5.status == NOT_STARTED:
                # keep track of start time/frame for later
                square5.tStart = t
                square5.frameNStart = frameN  # exact frame index
                square5.setAutoDraw(True)
            
            # *square9* updates
            if t >= 0.5 and square9.status == NOT_STARTED:
                # keep track of start time/frame for later
                square9.tStart = t
                square9.frameNStart = frameN  # exact frame index
                square9.setAutoDraw(True)
            
            # *square6* updates
            if t >= 0.5 and square6.status == NOT_STARTED:
                # keep track of start time/frame for later
                square6.tStart = t
                square6.frameNStart = frameN  # exact frame index
                square6.setAutoDraw(True)
            
            # *square1* updates
            if t >= 0.5 and square1.status == NOT_STARTED:
                # keep track of start time/frame for later
                square1.tStart = t
                square1.frameNStart = frameN  # exact frame index
                square1.setAutoDraw(True)
            
            # *square2* updates
            if t >= 0.5 and square2.status == NOT_STARTED:
                # keep track of start time/frame for later
                square2.tStart = t
                square2.frameNStart = frameN  # exact frame index
                square2.setAutoDraw(True)
            
            # *image1_* updates
            if t >= 0.5 and image1_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image1_.tStart = t
                image1_.frameNStart = frameN  # exact frame index
                image1_.setAutoDraw(True)
            
            # *image4_* updates
            if t >= 0.5 and image4_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image4_.tStart = t
                image4_.frameNStart = frameN  # exact frame index
                image4_.setAutoDraw(True)
            
            # *image3_* updates
            if t >= 0.5 and image3_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image3_.tStart = t
                image3_.frameNStart = frameN  # exact frame index
                image3_.setAutoDraw(True)
            
            # *image2_* updates
            if t >= 0.5 and image2_.status == NOT_STARTED:
                # keep track of start time/frame for later
                image2_.tStart = t
                image2_.frameNStart = frameN  # exact frame index
                image2_.setAutoDraw(True)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in presentDotComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "presentDot"-------
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        myMouse.setVisible(0)
        if str(response)==str(corrAns): # was the square that was clicked actually the odd one out?
            corrSquare=1
        else:
            corrSquare=0
        currentLoop.addData('response',response)
        currentLoop.addData('corrSquare',corrSquare)
        fp.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        fp_all.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
        
        event.clearEvents()
        # store data for spatialspan2 (TrialHandler)
        x, y = Mouse.getPos()
        buttons = Mouse.getPressed()
        spatialspan2.addData('Mouse.x', x)
        spatialspan2.addData('Mouse.y', y)
        spatialspan2.addData('Mouse.leftButton', buttons[0])
        spatialspan2.addData('Mouse.midButton', buttons[1])
        spatialspan2.addData('Mouse.rightButton', buttons[2])
        # the Routine "presentDot" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 1 repeats of 'spatialspan2'
    
    # get names of stimulus parameters
    if spatialspan2.trialList in ([], [None], None):
        params = []
    else:
        params = spatialspan2.trialList[0].keys()
    # save data for this loop
    spatialspan2.saveAsExcel(filename + '.xlsx', sheetName='spatialspan2',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "Q3"-------
    t = 0
    Q3Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    myMouse.setVisible(1) # This defines the mouse component, which is not visible in the builder view of the routine
    myMouse.clickReset() # Reset all attributes of the mouse at the start of the routine
    clickSequence=[] # empty list for storing the square numbers as items
    squares=[square1_,square2_,square3_,square4_,square5_,square6_,square7_,square8_,square9_] #a list of squares
    for square in range(0,9):   # I think this should be a range of 0,8 not 0,9?  
        squares[square].setSize([7,7]) #sets the size of the squares relative to the display
    
    # keep track of which components have finished
    Q3Components = [square4_, square5_, square6_, square7_, square8_, square1_, square2_, square3_, square9_, text_10]
    for thisComponent in Q3Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "Q3"-------
    while continueRoutine:
        # get current time
        t = Q3Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and store them as two lists 
        ##These next two lines were commented out, but not by JE##   
        #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    
        #event.clearEvents(myMouse)   
        if (mouse1):# if the first mouse button is pressed    
            mouse_x,mouse_y=myMouse.getPos()# assign the coordinates to variables    
            pix = [mouse_x, mouse_y]    #store the variables in a list. Originally, the code was based on an old version of Psychopy, where coordinates needed tp be converted to pixels. In the newer version this does not need to be done, Coordinates can be compared to other coordinates
            for square in range(0,9):    # evaluate the position of the mouse for all of the squares   
                if squares[square].contains(pix):#the next 3 lines of code originally shrunk the size of the squares, but it didn't work for the final click. I've now fixed it so it works.
                    squares[square].setSize([3,3])
                    win.flip()
                    core.wait(0.5)
                    if clickSequence==[]:#always true on the first trial
                        clickSequence.append(square+1) #add the number of the current square, plus 1 (number of squares starts at 0)
                    elif square+1<>clickSequence[-1]:  #if it doesn't equal, in old python language - so if it doesn't equal an empty list           
                        clickSequence.append(square+1)
                    if len(clickSequence)==len(respSequence): #when the number of clicks equals the number of expected clicks, end the routine
                            continueRoutine=False
                            event.clearEvents()    
        
        
        
        
        # *square4_* updates
        if t >= 0.0 and square4_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square4_.tStart = t
            square4_.frameNStart = frameN  # exact frame index
            square4_.setAutoDraw(True)
        
        # *square5_* updates
        if t >= 0.0 and square5_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square5_.tStart = t
            square5_.frameNStart = frameN  # exact frame index
            square5_.setAutoDraw(True)
        
        # *square6_* updates
        if t >= 0.0 and square6_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square6_.tStart = t
            square6_.frameNStart = frameN  # exact frame index
            square6_.setAutoDraw(True)
        
        # *square7_* updates
        if t >= 0.0 and square7_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square7_.tStart = t
            square7_.frameNStart = frameN  # exact frame index
            square7_.setAutoDraw(True)
        
        # *square8_* updates
        if t >= 0.0 and square8_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square8_.tStart = t
            square8_.frameNStart = frameN  # exact frame index
            square8_.setAutoDraw(True)
        
        # *square1_* updates
        if t >= 0.0 and square1_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square1_.tStart = t
            square1_.frameNStart = frameN  # exact frame index
            square1_.setAutoDraw(True)
        
        # *square2_* updates
        if t >= 0.0 and square2_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square2_.tStart = t
            square2_.frameNStart = frameN  # exact frame index
            square2_.setAutoDraw(True)
        
        # *square3_* updates
        if t >= 0.0 and square3_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square3_.tStart = t
            square3_.frameNStart = frameN  # exact frame index
            square3_.setAutoDraw(True)
        
        # *square9_* updates
        if t >= 0.0 and square9_.status == NOT_STARTED:
            # keep track of start time/frame for later
            square9_.tStart = t
            square9_.frameNStart = frameN  # exact frame index
            square9_.setAutoDraw(True)
        
        # *text_10* updates
        if t >= 0.5 and text_10.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_10.tStart = t
            text_10.frameNStart = frameN  # exact frame index
            text_10.setAutoDraw(True)
        frameRemains = 0.5 + 1.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if text_10.status == STARTED and t >= frameRemains:
            text_10.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in Q3Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "Q3"-------
    for thisComponent in Q3Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # I think this code does the scoring. It scores largely two things - 1) The number of times the items in each set were recalled in order to what was pressed in the processing phase.
    # and 2) The number of items recalled regardless of the order, of the items cliked on in the processing phase. e.g. span score and proportion score do factor in
    # whether the order was correct, while item score and proportionitemscore do not factor in whether the order was correct.
    if clickSequence==respSequence: #if the squares that were clicked on in processing were equal to the squares clicked on during recall, it is correct (note the comparson is between what is cliked on in the processing, regardless of whether that processing click itself was correct - i.e. the odd one, or not.
      spanCorr=1
      correctCount=correctCount+1
    else:
      spanCorr=0
    
    #determine if all items recalled, item doesn't matter 
    if list(set(clickSequence))==list(set(respSequence)):   #convert the lists into sets and compare them, ignoring the order  
        itemCorr=1 
    else:     
        itemCorr=0  
    
    #calculate proportion score
    #I think it calculates two proportions. The first is the number of items recalled in the correct position
    #'recallcount'. The second is the number of items recalled, regarldess of their order, 'item count'
    recallCount=0 
    itemCount=0
    for i in range(len(clickSequence)):     
        if clickSequence[i]==respSequence[i]:         
            recallCount=recallCount+1 
        if clickSequence[i] in respSequence:
            itemCount=itemCount+1
    if recallCount>0:     
        proportionScore=recallCount/len(respSequence) 
    else:     
        proportionScore=0       
    
    if itemCount>0:     
        proportionItemScore=itemCount/len(respSequence) 
    else:     
        proportionItemScore=0      
    
    currentLoop.addData('spanCorr',spanCorr)
    currentLoop.addData('clickSequence',clickSequence)
    currentLoop.addData('respSequence',respSequence)
    
    fs.write('%s,%s,%s,%s,%s,%s,"%s","%s","%s",%i,%.02f,%i,%.02f\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,spatialCorrectAnswer,respSequence,clickSequence,spanCorr,proportionScore,itemCorr,proportionItemScore)) #needs adding to so adds all data to each row
    fs_all.write('%s,%s,%s,%s,%s,%s,"%s","%s","%s",%i,%.02f,%i,%.02f\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,spatialCorrectAnswer,respSequence,clickSequence,spanCorr,proportionScore,itemCorr,proportionItemScore)) #needs adding to so adds all data to each row
    
    respSequence=[]
    # the Routine "Q3" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    t = 0
    feedbackClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(1.000000)
    # update component parameters for each repeat
    if spatialspan.thisTrialN in [2,5,8,11,14,17,20]:#if this is the end of the set-length after 3 repeats (trial number = cumulative trial number of the set length minus 1 - e.g. with set-length of 3, final trial would be 9 minus 1 = 8)
        if (correctCount== 0) or (correctCount== 1):
           feedbackString='welldone2.jpg'
           #spatialspan.finished=True
        else:
         feedbackList = ['greatjob2.jpg','brilliant2.jpg','fantastic2.jpg']
         feedbackNum = randint(3)
         feedbackString = feedbackList[feedbackNum]
    
    patch_2.setImage(feedbackString)
    # keep track of which components have finished
    feedbackComponents = [patch_2]
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        if spatialspan.thisTrialN not in [2,5,8,11,14,17,20]:
          continueRoutine=False
        
        
        
        # *patch_2* updates
        if t >= 0.0 and patch_2.status == NOT_STARTED:
            # keep track of start time/frame for later
            patch_2.tStart = t
            patch_2.frameNStart = frameN  # exact frame index
            patch_2.setAutoDraw(True)
        frameRemains = 0.0 + 1- win.monitorFramePeriod * 0.75  # most of one frame period left
        if patch_2.status == STARTED and t >= frameRemains:
            patch_2.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    if spatialspan.thisTrialN in [2,5,8,11,14,17,20]:
        #if correctCount<2:
        if (correctCount== 0) or (correctCount== 1):
            spatialspan.finished=True
        else:
            correctCount=0
    
    
    # ------Prepare to start Routine "break_2"-------
    t = 0
    break_2Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    
    # keep track of which components have finished
    break_2Components = [text_3]
    for thisComponent in break_2Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "break_2"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = break_2Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_3* updates
        if t >= 0.0 and text_3.status == NOT_STARTED:
            # keep track of start time/frame for later
            text_3.tStart = t
            text_3.frameNStart = frameN  # exact frame index
            text_3.setAutoDraw(True)
        frameRemains = 0.0 + 0.5- win.monitorFramePeriod * 0.75  # most of one frame period left
        if text_3.status == STARTED and t >= frameRemains:
            text_3.setAutoDraw(False)
        if spatialspan.thisTrialN in [8,11,14,17,20]:
          continueRoutine=False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in break_2Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "break_2"-------
    for thisComponent in break_2Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    thisExp.nextEntry()
    
# completed 1 repeats of 'spatialspan'

# get names of stimulus parameters
if spatialspan.trialList in ([], [None], None):
    params = []
else:
    params = spatialspan.trialList[0].keys()
# save data for this loop
spatialspan.saveAsExcel(filename + '.xlsx', sheetName='spatialspan',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('EndProcessingConditionList.xlsx'),
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial.keys():
        exec(paramName + '= thisTrial.' + paramName)

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial.keys():
            exec(paramName + '= thisTrial.' + paramName)
    
    # ------Prepare to start Routine "presentDot"-------
    t = 0
    presentDotClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    myMouse.setVisible(1)
    myMouse.clickReset()
    clickSequence=[] #empty variable to store the responses (square numbers) that are clicked during the processing routine
    squares=[square1,square2,square3,square4,square5,square6,square7,square8,square9] #list of square numbers as seen on the screen
    
    for square in range(0,9): #I think the range of squares should be  0 - 8. This is the original code (0 to 9) so I've kept it as the original
        squares[square].setSize([7,7])
    
    # setup some python lists for storing info about the Mouse
    image1_.setPos([Loc1x, Loc1y])
    image1_.setImage(image1)
    image4_.setPos([Loc4x, Loc4y])
    image4_.setImage(image4)
    image3_.setPos([Loc3x, Loc3y])
    image3_.setImage(image3)
    image2_.setPos([Loc2x, Loc2y])
    image2_.setImage(image2)
    # keep track of which components have finished
    presentDotComponents = [Mouse, square7, square8, square3, square4, square5, square9, square6, square1, square2, image1_, image4_, image3_, image2_]
    for thisComponent in presentDotComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "presentDot"-------
    while continueRoutine:
        # get current time
        t = presentDotClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        [mouse1,mouse2,mouse3], [RT1, RT2, RT3] = myMouse.getPressed(getTime = True) #get the attributes of the mouse and add them to two separate lists   
        #myMouse.clickReset() #rest time to 0 so can get accurate RT for next click    #this was commented out in the original script so I've left it as it is.
        #event.clearEvents(myMouse)  #again, commented out in the original script so left as it is
        #this set of code below gets details of the location of the mouse where cliked and adds it to a response sequence. The response sequence list is then
        #compared to a recalled sequence in the Q3 routine. 
        if (mouse1):
           mouse_x,mouse_y=myMouse.getPos()
           pix = [mouse_x, mouse_y] #pix is old code. Here we are just storing coordinates of the mouse location
           for square in range(0,9):
              if squares[square].contains(pix):
                 squares[square].setSize([3,3]) #shrinks the size of the square that was cliked, updates the screen and holds it for half a second
                 win.flip()
                 response=square+1
                 if respSequence==[]:  #always true on the first click           
                    respSequence.append(response)          
                 elif response<>respSequence[-1]:  #<> is old python way of saying 'not equal' - if it's not equal to an empty list?           
                    respSequence.append(response)             
                 core.wait(0.5)
                 continueRoutine=False
        
        
        
        
        # *square7* updates
        if t >= 0.5 and square7.status == NOT_STARTED:
            # keep track of start time/frame for later
            square7.tStart = t
            square7.frameNStart = frameN  # exact frame index
            square7.setAutoDraw(True)
        
        # *square8* updates
        if t >= 0.5 and square8.status == NOT_STARTED:
            # keep track of start time/frame for later
            square8.tStart = t
            square8.frameNStart = frameN  # exact frame index
            square8.setAutoDraw(True)
        
        # *square3* updates
        if t >= 0.5 and square3.status == NOT_STARTED:
            # keep track of start time/frame for later
            square3.tStart = t
            square3.frameNStart = frameN  # exact frame index
            square3.setAutoDraw(True)
        
        # *square4* updates
        if t >= 0.5 and square4.status == NOT_STARTED:
            # keep track of start time/frame for later
            square4.tStart = t
            square4.frameNStart = frameN  # exact frame index
            square4.setAutoDraw(True)
        
        # *square5* updates
        if t >= 0.5 and square5.status == NOT_STARTED:
            # keep track of start time/frame for later
            square5.tStart = t
            square5.frameNStart = frameN  # exact frame index
            square5.setAutoDraw(True)
        
        # *square9* updates
        if t >= 0.5 and square9.status == NOT_STARTED:
            # keep track of start time/frame for later
            square9.tStart = t
            square9.frameNStart = frameN  # exact frame index
            square9.setAutoDraw(True)
        
        # *square6* updates
        if t >= 0.5 and square6.status == NOT_STARTED:
            # keep track of start time/frame for later
            square6.tStart = t
            square6.frameNStart = frameN  # exact frame index
            square6.setAutoDraw(True)
        
        # *square1* updates
        if t >= 0.5 and square1.status == NOT_STARTED:
            # keep track of start time/frame for later
            square1.tStart = t
            square1.frameNStart = frameN  # exact frame index
            square1.setAutoDraw(True)
        
        # *square2* updates
        if t >= 0.5 and square2.status == NOT_STARTED:
            # keep track of start time/frame for later
            square2.tStart = t
            square2.frameNStart = frameN  # exact frame index
            square2.setAutoDraw(True)
        
        # *image1_* updates
        if t >= 0.5 and image1_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image1_.tStart = t
            image1_.frameNStart = frameN  # exact frame index
            image1_.setAutoDraw(True)
        
        # *image4_* updates
        if t >= 0.5 and image4_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image4_.tStart = t
            image4_.frameNStart = frameN  # exact frame index
            image4_.setAutoDraw(True)
        
        # *image3_* updates
        if t >= 0.5 and image3_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image3_.tStart = t
            image3_.frameNStart = frameN  # exact frame index
            image3_.setAutoDraw(True)
        
        # *image2_* updates
        if t >= 0.5 and image2_.status == NOT_STARTED:
            # keep track of start time/frame for later
            image2_.tStart = t
            image2_.frameNStart = frameN  # exact frame index
            image2_.setAutoDraw(True)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in presentDotComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "presentDot"-------
    for thisComponent in presentDotComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    myMouse.setVisible(0)
    if str(response)==str(corrAns): # was the square that was clicked actually the odd one out?
        corrSquare=1
    else:
        corrSquare=0
    currentLoop.addData('response',response)
    currentLoop.addData('corrSquare',corrSquare)
    fp.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
    fp_all.write('%s,%s,%s,%s,%s,%s,%s,%i,%f,%i\n' %(expInfo['participant'],expInfo['date'],expInfo['expName'],Block,Span,trial,corrAns,response,RT1,corrSquare)) #needs adding to so adds all data to each row
    
    event.clearEvents()
    # store data for trials (TrialHandler)
    x, y = Mouse.getPos()
    buttons = Mouse.getPressed()
    trials.addData('Mouse.x', x)
    trials.addData('Mouse.y', y)
    trials.addData('Mouse.leftButton', buttons[0])
    trials.addData('Mouse.midButton', buttons[1])
    trials.addData('Mouse.rightButton', buttons[2])
    # the Routine "presentDot" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 0 repeats of 'trials'

# get names of stimulus parameters
if trials.trialList in ([], [None], None):
    params = []
else:
    params = trials.trialList[0].keys()
# save data for this loop
trials.saveAsExcel(filename + '.xlsx', sheetName='trials',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "Finish"-------
t = 0
FinishClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(2.000000)
# update component parameters for each repeat
# keep track of which components have finished
FinishComponents = [text_end]
for thisComponent in FinishComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Finish"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = FinishClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_end* updates
    if t >= 0 and text_end.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_end.tStart = t
        text_end.frameNStart = frameN  # exact frame index
        text_end.setAutoDraw(True)
    frameRemains = 0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if text_end.status == STARTED and t >= frameRemains:
        text_end.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in FinishComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Finish"-------
for thisComponent in FinishComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
fp.close()
fs.close()

fp.close()
fs.close()

fp.close()
fs.close()




fp.close()
fs.close()

fp.close()
fs.close()
fp_all.close()
fs_all.close()

fp.close()
fs.close()
# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
